/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#define PY_SSIZE_T_CLEAN
#include <Python.h>




#if PY_VERSION_HEX < 0x02050000
typedef int Py_ssize_t;
#define PY_SSIZE_T_MAX INT_MAX
#define PY_SSIZE_T_MIN INT_MIN
typedef inquiry lenfunc;
typedef intargfunc ssizeargfunc;
typedef intobjargproc ssizeobjargproc;
#endif


#line 3 "./cogl.override"
#define NO_IMPORT_PYGOBJECT
#include "pygobject.h"

#include "pyclutter-private.h"

#include <cogl/cogl.h>


PyTypeObject PyCoglTexture_Type;
PyTypeObject PyCoglMatrix_Type;
PyTypeObject PyCoglMaterial_Type;
PyTypeObject PyCoglShader_Type;
PyTypeObject PyCoglProgram_Type;
PyTypeObject PyCoglOffscreen_Type;


#line 37 "cogl.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyPangoLayout_Type;
#define PyPangoLayout_Type (*_PyPangoLayout_Type)
static PyTypeObject *_PyPangoLayoutLine_Type;
#define PyPangoLayoutLine_Type (*_PyPangoLayoutLine_Type)
static PyTypeObject *_PyPangoCairoFontMap_Type;
#define PyPangoCairoFontMap_Type (*_PyPangoCairoFontMap_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject G_GNUC_INTERNAL PyCoglPangoFontMap_Type;


#line 21 "./cogl.override"

PyObject *
pycogl_handle_from_handle (CoglHandle handle)
{
  PyTypeObject *type = NULL;
  PyObject *o;

  /* if the handle is invalid we just return Py_None */
  if (handle == COGL_INVALID_HANDLE) {
      Py_INCREF (Py_None);
      return Py_None;
  }

  if (cogl_is_texture (handle))
    type = &PyCoglTexture_Type;
  else if (cogl_is_material (handle))
    type = &PyCoglMaterial_Type;
  else if (cogl_is_shader (handle))
    type = &PyCoglShader_Type;
  else if (cogl_is_program (handle))
    type = &PyCoglProgram_Type;
  else if (cogl_is_offscreen (handle))
    type = &PyCoglOffscreen_Type;
  else {
      PyErr_SetString (PyExc_TypeError, "Unknown handle type");
      return NULL;
  }

  o = type->tp_alloc (type, 0);
  if (o == NULL) {
      /* blubb */
      return NULL;
  } else {
      ((PyCoglHandle *)o)->handle = handle;
      cogl_handle_ref (handle);
  }
  return o;
}

PyObject *
pycogl_handle_from_handle_without_ref (CoglHandle handle)
{
  PyObject *o = pycogl_handle_from_handle(handle);
  if (o) {
      cogl_handle_unref(handle);
  }
  return o;
}

static PyObject *
pycogl_handle_new (PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
  PyErr_SetString (PyExc_TypeError,
                   "cogl.Handle type cannot be instantiated");
  return NULL;
}

void
pycogl_handle_dealloc (PyCoglHandle *self)
{
  if (self->handle) 
    {
      cogl_handle_unref (self->handle);
      self->handle = NULL;
    }
  self->ob_type->tp_free((PyObject *)self);
}

PyTypeObject PyCoglHandle_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                  /* ob_size */
    "cogl.Handle",                      /* tp_name */
    sizeof(PyCoglHandle),               /* tp_basicsize */
    0,                                  /* tp_itemsize */
    (destructor)pycogl_handle_dealloc,  /* tp_dealloc */
    0,                                  /* tp_print */
    0,                                  /* tp_getattr */
    0,                                  /* tp_setattr */
    0,                                  /* tp_compare */
    0,                                  /* tp_repr */
    0,                                  /* tp_as_number */
    0,                                  /* tp_as_sequence */
    0,                                  /* tp_as_mapping */
    0,                                  /* tp_hash */
    0,                                  /* tp_call */
    0,                                  /* tp_str */
    0,                                  /* tp_getattro */
    0,                                  /* tp_setattro */
    0,                                  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE,/* tp_flags */
    0,                                  /* tp_doc */
    0,                                  /* tp_traverse */
    0,                                  /* tp_clear */
    0,                                  /* tp_richcompare */
    0,                                  /* tp_weaklistoffset */
    0,                                  /* tp_iter */
    0,                                  /* tp_iternext */
    0,                                  /* tp_methods */
    0,                                  /* tp_members */
    0,                                  /* tp_getset */
    0, /* &PyBaseObject_Type, */        /* tp_base */
    0,                                  /* tp_dict */
    0,                                  /* tp_descr_get */
    0,                                  /* tp_descr_set */
    0,                                  /* tp_dictoffset */
    0,                                  /* tp_init */
    0,                                  /* tp_alloc */
    (newfunc)pycogl_handle_new,         /* tp_new */
    0,                                  /* tp_free */
    0,                                  /* tp_is_gc */
    0,                                  /* tp_bases */
};


static PyObject *
pyobject_from_cogl_color (CoglColor *color)
{
  PyObject *pyret;
  pyret = Py_BuildValue ("(ffff)",
                         cogl_color_get_red_float (color),
                         cogl_color_get_green_float (color),
                         cogl_color_get_blue_float (color),
                         cogl_color_get_alpha_float (color));
  return pyret;
}



#line 15 "cogl-texture.override"

/*
 * cogl.Texture handle
 *
 * This is a custom python handle to provide methods for a cogl texture
 * handle.
 */
static PyObject *
pycogl_texture_new (PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
  /* XXX: What to choose as constructor? _from_file, _from_size ? */
  PyErr_SetString (PyExc_TypeError,
                   "cogl.Handle type cannot be instantiated");
  return NULL;
}

static PyObject *
pycogl_texture_get_width (PyCoglTexture *self)
{
  return Py_BuildValue ("i", cogl_texture_get_width (self->handle));
}

static PyObject *
pycogl_texture_get_height (PyCoglTexture *self)
{
  return Py_BuildValue ("i", cogl_texture_get_height (self->handle));
}

static PyObject *
pycogl_texture_get_format (PyCoglTexture *self)
{
  return pyg_enum_from_gtype (COGL_TYPE_PIXEL_FORMAT,
                              cogl_texture_get_format (self->handle));
}

static PyObject *
pycogl_texture_get_rowstride (PyCoglTexture *self)
{
  return Py_BuildValue ("i", cogl_texture_get_rowstride (self->handle));
}

static PyObject *
pycogl_texture_get_max_waste (PyCoglTexture *self)
{
  return Py_BuildValue ("i", cogl_texture_get_max_waste (self->handle));
}

static PyObject *
pycogl_texture_is_sliced (PyCoglTexture *self)
{
  return PyBool_FromLong (cogl_texture_is_sliced (self->handle));
}

static PyObject *
pycogl_texture_get_gl_texture (PyCoglTexture *self)
{
  GLuint gl_handle = 0;
  GLenum gl_target = 0;

  if (!cogl_texture_get_gl_texture (self->handle, &gl_handle, &gl_target))
    return Py_BuildValue ("()");

  return Py_BuildValue ("(ii)", gl_handle, gl_target);
}

static PyObject *
pycogl_texture_get_data (PyCoglTexture *self, PyObject *args)
{
  CoglPixelFormat format;
  guint rowstride = 0;
  guchar *data = NULL;
  gint size = 0;

  if (!PyArg_ParseTuple (args, "i|I:cogl.Texture.get_data",
                         &format, &rowstride))
    return NULL;

  size = cogl_texture_get_data (self->handle, format, rowstride, data);

  if (size != 0)
  {
      PyObject *py_data;

      data = (guchar*) g_malloc (sizeof (guchar) * size);
      cogl_texture_get_data (self->handle, format, rowstride, data);
      py_data = Py_BuildValue ("s#", data, size);
      g_free (data);

      return py_data;
  }

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_texture_set_region (PyCoglTexture *self, PyObject *args)
{
  gint src_x, src_y, dst_x, dst_y, width, height;
  guint dst_width, dst_height, rowstride;
  PyObject *py_format;
  CoglPixelFormat format;
  guchar *data;
  gboolean ret;

  if (!PyArg_ParseTuple (args, "iiiiiiiiOis:cogl.Texture.set_region",
                         &src_x, &src_y, &dst_x, &dst_y,
                         &dst_width, &dst_height, &width, &height,
                         &py_format, &rowstride, &data))
    return NULL;

  if (pyg_enum_get_value (COGL_TYPE_PIXEL_FORMAT, py_format,
                          (gpointer)&format))
    return NULL;

  ret = cogl_texture_set_region (self->handle, src_x, src_y, dst_x, dst_y,
                                 dst_width, dst_height, width, height, format,
                                 rowstride, data);
  
  return PyBool_FromLong (ret);
}


static PyMethodDef pycogl_texture_methods[] = {
    { "get_width", (PyCFunction)pycogl_texture_get_width, METH_NOARGS },
    { "get_height", (PyCFunction)pycogl_texture_get_height, METH_NOARGS },
    { "get_format", (PyCFunction)pycogl_texture_get_format, METH_NOARGS },
    { "get_rowstride", (PyCFunction)pycogl_texture_get_rowstride, METH_NOARGS },
    { "get_max_waste", (PyCFunction)pycogl_texture_get_max_waste, METH_NOARGS },
    { "is_sliced", (PyCFunction)pycogl_texture_is_sliced, METH_NOARGS },
    { "get_gl_texture", (PyCFunction)pycogl_texture_get_gl_texture, METH_NOARGS },
    { "get_data", (PyCFunction)pycogl_texture_get_data, METH_VARARGS },
    { "set_region", (PyCFunction)pycogl_texture_set_region, METH_VARARGS },
    { NULL, NULL, 0, NULL },
};

PyTypeObject PyCoglTexture_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                  /* ob_size */
    "cogl.Texture",                     /* tp_name */
    sizeof(PyCoglTexture),              /* tp_basicsize */
    0,                                  /* tp_itemsize */
    (destructor)pycogl_handle_dealloc,  /* tp_dealloc */
    0,                                  /* tp_print */
    0,                                  /* tp_getattr */
    0,                                  /* tp_setattr */
    0,                                  /* tp_compare */
    0,                                  /* tp_repr */
    0,                                  /* tp_as_number */
    0,                                  /* tp_as_sequence */
    0,                                  /* tp_as_mapping */
    0,                                  /* tp_hash */
    0,                                  /* tp_call */
    0,                                  /* tp_str */
    0,                                  /* tp_getattro */
    0,                                  /* tp_setattro */
    0,                                  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT,                 /* tp_flags */
    0,                                  /* tp_doc */
    0,                                  /* tp_traverse */
    0,                                  /* tp_clear */
    0,                                  /* tp_richcompare */
    0,                                  /* tp_weaklistoffset */
    0,                                  /* tp_iter */
    0,                                  /* tp_iternext */
    pycogl_texture_methods,             /* tp_methods */
    0,                                  /* tp_members */
    0,                                  /* tp_getset */
    0, /* &PyCoglHandle_Type, */        /* tp_base */
    0,                                  /* tp_dict */
    0,                                  /* tp_descr_get */
    0,                                  /* tp_descr_set */
    0,                                  /* tp_dictoffset */
    0,                                  /* tp_init */
    0,                                  /* tp_alloc */
    (newfunc)pycogl_texture_new,        /* tp_new */
    0,                                  /* tp_free */
    0,                                  /* tp_is_gc */
    0,                                  /* tp_bases */
};


#line 9 "cogl-material.override"
/* COGL Material handle */

static PyObject *
pycogl_material_new (PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
  static char *kwlist [] = { "source", NULL };
  PyCoglMaterial *py_source;
  CoglHandle handle;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "|O!:cogl.Material.__init__",
                                    kwlist,
                                    &PyCoglMaterial_Type, &py_source))
    return NULL;

  if (py_source->handle != COGL_INVALID_HANDLE)
    handle = cogl_material_copy (py_source->handle);
  else
    handle = cogl_material_new ();

  return pycogl_handle_from_handle_without_ref (handle);
}

static PyObject *
pycogl_material_set_color (PyCoglMaterial *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.Material.set_color",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    return NULL;

  cogl_material_set_color (self->handle, &color);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_get_color (PyCoglMaterial *self)
{
  CoglColor color;
  PyObject *py_ret;

  cogl_material_get_color (self->handle, &color);
  py_ret = pyobject_from_cogl_color (&color);

  return py_ret;
}

static PyObject *
pycogl_material_set_color4ub (PyCoglMaterial *self,
                              PyObject *args,
                              PyObject *kwargs)
{
  static char *kwlist[] = { "red", "green", "blue", "alpha", NULL };
  guint8 red, green, blue, alpha;
  red = green = blue = 0x0;
  alpha = 0xff;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "|HHHH:cogl.Material.set_color4ub",
                                    kwlist,
                                    &red, &green, &blue, &alpha))
    return NULL;

  cogl_material_set_color4ub (self->handle, red, green, blue, alpha);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_set_color4f (PyCoglMaterial *self,
                             PyObject *args,
                             PyObject *kwargs)
{
  static char *kwlist[] = { "red", "green", "blue", "alpha", NULL };
  float red, green, blue, alpha;
  red = green = blue = 0.0;
  alpha = 1.0;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "|ffff:cogl.Material.set_color4ub",
                                    kwlist,
                                    &red, &green, &blue, &alpha))
    return NULL;

  cogl_material_set_color4f (self->handle, red, green, blue, alpha);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_set_ambient (PyCoglMaterial *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.Material.set_ambient",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    return NULL;

  cogl_material_set_ambient (self->handle, &color);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_get_ambient (PyCoglMaterial *self)
{
  CoglColor color;
  PyObject *py_ret;

  cogl_material_get_ambient (self->handle, &color);
  py_ret = pyobject_from_cogl_color (&color);

  return py_ret;
}

static PyObject *
pycogl_material_set_diffuse (PyCoglMaterial *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.Material.set_diffuse",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    return NULL;

  cogl_material_set_diffuse (self->handle, &color);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_get_diffuse (PyCoglMaterial *self)
{
  CoglColor color;
  PyObject *py_ret;

  cogl_material_get_diffuse (self->handle, &color);
  py_ret = pyobject_from_cogl_color (&color);

  return py_ret;
}

static PyObject *
pycogl_material_set_ambient_and_diffuse (PyCoglMaterial *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.Material.set_ambient",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    return NULL;

  cogl_material_set_ambient_and_diffuse (self->handle, &color);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_set_emission (PyCoglMaterial *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.Material.set_emission",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    return NULL;

  cogl_material_set_emission (self->handle, &color);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_get_emission (PyCoglMaterial *self)
{
  CoglColor color;
  PyObject *py_ret;

  cogl_material_get_emission (self->handle, &color);
  py_ret = pyobject_from_cogl_color (&color);

  return py_ret;
}

static PyObject *
pycogl_material_set_specular (PyCoglMaterial *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.Material.set_specular",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    return NULL;

  cogl_material_set_specular (self->handle, &color);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_get_specular (PyCoglMaterial *self)
{
  CoglColor color;
  PyObject *py_ret;

  cogl_material_get_specular (self->handle, &color);
  py_ret = pyobject_from_cogl_color (&color);

  return py_ret;
}

static PyObject *
pycogl_material_set_shininess (PyCoglMaterial *self, PyObject *args)
{
  float shininess;
  if (!PyArg_ParseTuple (args, "f:cogl.Material.set_shininess",
                         &shininess))
    return NULL;

  cogl_material_set_shininess (self->handle, shininess);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_get_shininess (PyCoglMaterial *self)
{
  return Py_BuildValue ("f", cogl_material_get_shininess (self->handle));
}

static PyObject *
pycogl_material_set_alpha_test_function (PyCoglMaterial *self,
                                         PyObject       *args)
{
  PyObject *py_alpha_func;
  CoglMaterialAlphaFunc alpha_func;
  float alpha_reference;

  if (!PyArg_ParseTuple (args, "Of:cogl.Material.set_alpha_test_function",
                         &py_alpha_func, &alpha_reference))
    return NULL;

  if (pyg_enum_get_value (COGL_TYPE_MATERIAL_ALPHA_FUNC, py_alpha_func,
                          (gpointer)&alpha_func))
    return NULL;

  cogl_material_set_alpha_test_function (self->handle, alpha_func,
                                         alpha_reference);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_set_blend (PyCoglMaterial *self, PyObject *args)
{
  const char *blend_string;
  GError *error = NULL;
  gboolean ret;

  if (!PyArg_ParseTuple (args, "s:cogl.Material.set_blend",
                         &blend_string))
    return NULL;

  ret = cogl_material_set_blend (self->handle, blend_string, &error);

  if (!ret && error != NULL)
    {
      PyErr_Format (PyExc_RuntimeError, " %s", error->message);
      g_error_free (error);
      return NULL;
    }

  return PyBool_FromLong (ret);
}

static PyObject *
pycogl_material_set_blend_constant (PyCoglMaterial *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.Material.set_blend_constant",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    return NULL;

  cogl_material_set_blend_constant (self->handle, &color);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_set_layer (PyCoglMaterial *self, PyObject *args)
{
  int index;
  PyCoglTexture *texture;

  if (!PyArg_ParseTuple (args, "iO!:cogl.Material.set_layer",
                         &index, &PyCoglTexture_Type, &texture))
    return NULL;

  cogl_material_set_layer (self->handle, index, texture->handle);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_remove_layer (PyCoglMaterial *self, PyObject *args)
{
  int index;

  if (!PyArg_ParseTuple (args, "i:cogl.Material.remove_layer",
                         &index))
    return NULL;

  cogl_material_remove_layer (self->handle, index);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_set_layer_combine (PyCoglMaterial *self, PyObject *args)
{
  int index;
  const char *blend_string;
  GError *error = NULL;
  gboolean ret;

  if (!PyArg_ParseTuple (args, "is:cogl.Material.set_layer_combine",
                         &index, &blend_string))
    return NULL;

  ret = cogl_material_set_layer_combine (self->handle, index, blend_string,
                                         &error);

  if (!ret && error != NULL)
    {
      PyErr_Format (PyExc_RuntimeError, " %s", error->message);
      g_error_free (error);
      return NULL;
    }

  return PyBool_FromLong (ret);
}

static PyObject *
pycogl_material_set_layer_matrix (PyCoglMaterial *self, PyObject *args)
{
  int index;
  PyCoglMatrix *py_matrix;

  if (!PyArg_ParseTuple (args, "iO!:cogl.Material.set_layer_matrix",
                         &index, &PyCoglMatrix_Type, &py_matrix))
    return NULL;

  cogl_material_set_layer_matrix (self->handle, index, &py_matrix->matrix);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_material_get_layers (PyCoglMaterial *self)
{
  const GList *layers;
  GList *l;
  PyObject *py_list;

  layers = cogl_material_get_layers (self->handle);

  py_list = PyList_New (0);

  for (l = (GList *)layers; l != NULL; l = l->next)
    {
      PyObject *py_layer;
      CoglHandle handle = l->data;

      py_layer = pycogl_handle_from_handle (handle);

      if (!py_layer)
        {
          Py_DECREF (py_list);
          return NULL;
        }

      PyList_Append (py_list, py_layer);
    }

  return py_list;
}

static PyObject *
pycogl_material_get_n_layers (PyCoglMaterial *self)
{
  return Py_BuildValue ("i", cogl_material_get_n_layers (self->handle));
}

static PyObject *
pycogl_material_set_layer_filters (PyCoglMaterial *self, PyObject *args)
{
  gint layer_index;
  PyObject *py_min_filter, *py_mag_filter;
  CoglMaterialFilter min_filter, mag_filter;

  if (!PyArg_ParseTuple (args, "iOO:cogl.Material.set_layer_filters",
                         &layer_index, &py_min_filter, &py_mag_filter))
    return NULL;

  if (pyg_enum_get_value (COGL_TYPE_MATERIAL_FILTER, py_min_filter,
                          (gpointer)&min_filter))
    return NULL;

  if (pyg_enum_get_value (COGL_TYPE_MATERIAL_FILTER, py_mag_filter,
                          (gpointer)&mag_filter))
    return NULL;

  cogl_material_set_layer_filters (self->handle, layer_index,
                                   min_filter, mag_filter);

  Py_INCREF (Py_None);
  return Py_None;
}


static PyMethodDef pycogl_material_methods[] = {
    { "set_color", (PyCFunction)pycogl_material_set_color, METH_VARARGS },
    { "get_color", (PyCFunction)pycogl_material_get_color, METH_NOARGS },
    { "set_color4ub", (PyCFunction)pycogl_material_set_color4ub, METH_VARARGS|METH_KEYWORDS },
    { "set_color4f", (PyCFunction)pycogl_material_set_color4f, METH_VARARGS|METH_KEYWORDS },
    { "set_ambient", (PyCFunction)pycogl_material_set_ambient, METH_VARARGS },
    { "get_ambient", (PyCFunction)pycogl_material_get_ambient, METH_NOARGS },
    { "set_diffuse", (PyCFunction)pycogl_material_set_diffuse, METH_VARARGS },
    { "get_diffuse", (PyCFunction)pycogl_material_get_diffuse, METH_NOARGS },
    { "set_ambient_and_diffuse", (PyCFunction)pycogl_material_set_ambient_and_diffuse, METH_VARARGS },
    { "set_emission", (PyCFunction)pycogl_material_set_emission, METH_VARARGS },
    { "get_emission", (PyCFunction)pycogl_material_get_emission, METH_NOARGS },
    { "set_specular", (PyCFunction)pycogl_material_set_specular, METH_VARARGS },
    { "get_specular", (PyCFunction)pycogl_material_get_specular, METH_NOARGS },
    { "set_shininess", (PyCFunction)pycogl_material_set_shininess, METH_VARARGS },
    { "get_shininess", (PyCFunction)pycogl_material_get_shininess, METH_NOARGS },
    { "set_alpha_test_function", (PyCFunction)pycogl_material_set_alpha_test_function, METH_VARARGS },
    { "set_blend", (PyCFunction)pycogl_material_set_blend, METH_VARARGS },
    { "set_blend_constant", (PyCFunction)pycogl_material_set_blend_constant, METH_VARARGS },
    { "set_layer", (PyCFunction)pycogl_material_set_layer, METH_VARARGS },
    { "remove_layer", (PyCFunction)pycogl_material_remove_layer, METH_VARARGS },
    { "set_layer_combine", (PyCFunction)pycogl_material_set_layer_combine, METH_VARARGS },
    { "set_layer_matrix", (PyCFunction)pycogl_material_set_layer_matrix, METH_VARARGS },
    { "get_layers", (PyCFunction)pycogl_material_get_layers, METH_NOARGS },
    { "get_n_layers", (PyCFunction)pycogl_material_get_n_layers, METH_NOARGS },
    { "set_layer_filters", (PyCFunction)pycogl_material_set_layer_filters, METH_VARARGS },
    { NULL, NULL, 0, NULL },
};

PyTypeObject PyCoglMaterial_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                  /* ob_size */
    "cogl.Material",                    /* tp_name */
    sizeof(PyCoglMaterial),             /* tp_basicsize */
    0,                                  /* tp_itemsize */
    (destructor)pycogl_handle_dealloc,  /* tp_dealloc */
    0,                                  /* tp_print */
    0,                                  /* tp_getattr */
    0,                                  /* tp_setattr */
    0,                                  /* tp_compare */
    0,                                  /* tp_repr */
    0,                                  /* tp_as_number */
    0,                                  /* tp_as_sequence */
    0,                                  /* tp_as_mapping */
    0,                                  /* tp_hash */
    0,                                  /* tp_call */
    0,                                  /* tp_str */
    0,                                  /* tp_getattro */
    0,                                  /* tp_setattro */
    0,                                  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT,                 /* tp_flags */
    0,                                  /* tp_doc */
    0,                                  /* tp_traverse */
    0,                                  /* tp_clear */
    0,                                  /* tp_richcompare */
    0,                                  /* tp_weaklistoffset */
    0,                                  /* tp_iter */
    0,                                  /* tp_iternext */
    pycogl_material_methods,            /* tp_methods */
    0,                                  /* tp_members */
    0,                                  /* tp_getset */
    0, /* &PyCoglHandle_Type, */        /* tp_base */
    0,                                  /* tp_dict */
    0,                                  /* tp_descr_get */
    0,                                  /* tp_descr_set */
    0,                                  /* tp_dictoffset */
    0,                                  /* tp_init */
    0,                                  /* tp_alloc */
    (newfunc)pycogl_material_new,       /* tp_new */
    0,                                  /* tp_free */
    0,                                  /* tp_is_gc */
    0,                                  /* tp_bases */
};



#line 13 "cogl-shader.override"

/* COGL Shader */

static PyObject *
pycogl_shader_new (PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "shader_type", NULL };
  PyObject *py_type;
  CoglShaderType shader_type;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "O", kwlist, &py_type))
    return NULL;

  if (pyg_enum_get_value (COGL_TYPE_SHADER_TYPE, py_type,
                          (gpointer)&shader_type))
    return NULL;

  return pycogl_handle_from_handle_without_ref (cogl_create_shader (shader_type));
}

static PyObject *
pycogl_shader_source (PyCoglShader *self, PyObject *args)
{
  const gchar *source;

  if (!PyArg_ParseTuple (args, "s:cogl.Shader.source",
                         &source))
    return NULL;

  cogl_shader_source (self->handle, source);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_shader_compile (PyCoglShader *self)
{
  cogl_shader_compile (self->handle);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_shader_get_info_log (PyCoglShader *self)
{
  return Py_BuildValue ("s", cogl_shader_get_info_log (self->handle));
}

static PyObject *
pycogl_shader_is_compiled (PyCoglShader *self)
{
  return PyBool_FromLong (cogl_shader_is_compiled (self->handle));
}


static PyMethodDef pycogl_shader_methods[] = {
    { "source", (PyCFunction)pycogl_shader_source, METH_VARARGS },
    { "compile", (PyCFunction)pycogl_shader_compile, METH_NOARGS },
    { "get_info_log", (PyCFunction)pycogl_shader_get_info_log, METH_NOARGS },
    { "is_compiled", (PyCFunction)pycogl_shader_is_compiled, METH_NOARGS },
    { NULL, NULL, 0, NULL },
};

PyTypeObject PyCoglShader_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                  /* ob_size */
    "cogl.Shader",                      /* tp_name */
    sizeof(PyCoglShader),               /* tp_basicsize */
    0,                                  /* tp_itemsize */
    (destructor)pycogl_handle_dealloc,  /* tp_dealloc */
    0,                                  /* tp_print */
    0,                                  /* tp_getattr */
    0,                                  /* tp_setattr */
    0,                                  /* tp_compare */
    0,                                  /* tp_repr */
    0,                                  /* tp_as_number */
    0,                                  /* tp_as_sequence */
    0,                                  /* tp_as_mapping */
    0,                                  /* tp_hash */
    0,                                  /* tp_call */
    0,                                  /* tp_str */
    0,                                  /* tp_getattro */
    0,                                  /* tp_setattro */
    0,                                  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT,                 /* tp_flags */
    0,                                  /* tp_doc */
    0,                                  /* tp_traverse */
    0,                                  /* tp_clear */
    0,                                  /* tp_richcompare */
    0,                                  /* tp_weaklistoffset */
    0,                                  /* tp_iter */
    0,                                  /* tp_iternext */
    pycogl_shader_methods,              /* tp_methods */
    0,                                  /* tp_members */
    0,                                  /* tp_getset */
    0, /* &PyCoglHandle_Type, */        /* tp_base */
    0,                                  /* tp_dict */
    0,                                  /* tp_descr_get */
    0,                                  /* tp_descr_set */
    0,                                  /* tp_dictoffset */
    0,                                  /* tp_init */
    0,                                  /* tp_alloc */
    (newfunc)pycogl_shader_new,         /* tp_new */
    0,                                  /* tp_free */
    0,                                  /* tp_is_gc */
    0,                                  /* tp_bases */
};


static PyObject *
pycogl_program_new (PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
  return pycogl_handle_from_handle_without_ref (cogl_create_program ());
}

static PyObject *
pycogl_program_attach_shader (PyCoglProgram *self, PyObject *args)
{
  PyCoglShader *py_shader;
  
  if (!PyArg_ParseTuple (args, "O!:cogl.Program.attach_shader",
                         &PyCoglShader_Type, &py_shader))
    return NULL;

  cogl_program_attach_shader (self->handle, py_shader->handle);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_program_link (PyCoglProgram *self)
{
  cogl_program_link (self->handle);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_program_use (PyCoglProgram *self)
{
  cogl_program_use (self->handle);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_program_get_uniform_location (PyCoglProgram *self, PyObject *args)
{
  const char *uniform_name;
  int ret;

  if (!PyArg_ParseTuple (args, "s:cogl.Program.get_uniform_location",
                         &uniform_name))
    return NULL;

  ret = cogl_program_get_uniform_location (self->handle, uniform_name);

  return Py_BuildValue ("i", ret);
}


static PyMethodDef pycogl_program_methods[] = {
    { "attach_shader", (PyCFunction)pycogl_program_attach_shader, METH_VARARGS },
    { "link", (PyCFunction)pycogl_program_link, METH_NOARGS },
    { "use", (PyCFunction)pycogl_program_use, METH_NOARGS },
    { "get_uniform_location", (PyCFunction)pycogl_program_get_uniform_location, METH_VARARGS },
    { NULL, NULL, 0, NULL },
};

PyTypeObject PyCoglProgram_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                  /* ob_size */
    "cogl.Program",                     /* tp_name */
    sizeof(PyCoglProgram),              /* tp_basicsize */
    0,                                  /* tp_itemsize */
    (destructor)pycogl_handle_dealloc,  /* tp_dealloc */
    0,                                  /* tp_print */
    0,                                  /* tp_getattr */
    0,                                  /* tp_setattr */
    0,                                  /* tp_compare */
    0,                                  /* tp_repr */
    0,                                  /* tp_as_number */
    0,                                  /* tp_as_sequence */
    0,                                  /* tp_as_mapping */
    0,                                  /* tp_hash */
    0,                                  /* tp_call */
    0,                                  /* tp_str */
    0,                                  /* tp_getattro */
    0,                                  /* tp_setattro */
    0,                                  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT,                 /* tp_flags */
    0,                                  /* tp_doc */
    0,                                  /* tp_traverse */
    0,                                  /* tp_clear */
    0,                                  /* tp_richcompare */
    0,                                  /* tp_weaklistoffset */
    0,                                  /* tp_iter */
    0,                                  /* tp_iternext */
    pycogl_program_methods,             /* tp_methods */
    0,                                  /* tp_members */
    0,                                  /* tp_getset */
    0, /* &PyCoglHandle_Type, */        /* tp_base */
    0,                                  /* tp_dict */
    0,                                  /* tp_descr_get */
    0,                                  /* tp_descr_set */
    0,                                  /* tp_dictoffset */
    0,                                  /* tp_init */
    0,                                  /* tp_alloc */
    (newfunc)pycogl_program_new,        /* tp_new */
    0,                                  /* tp_free */
    0,                                  /* tp_is_gc */
    0,                                  /* tp_bases */
};

#line 15 "cogl-matrix.override"

/* COGL Matrix */
static PyObject *
pycogl_matrix_new (PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
  PyCoglMatrix *self;

  self = (PyCoglMatrix *)type->tp_alloc(type, 0);
  return (PyObject *)self;
}

static int
pycogl_matrix_init (PyCoglMatrix *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "array", NULL };
  PyObject *py_array = NULL;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "|O:cogl.Matrix",
                                    kwlist, &py_array))
    return -1;

  if (py_array == NULL)
    cogl_matrix_init_identity (&self->matrix);
  else if (!PyTuple_Check (py_array) || PyTuple_Size (py_array) != 16)
    {
      PyErr_SetString (PyExc_ValueError,
                       "array must be a tuple of 16 floats");
      return -1;
    }
  else
    {
      float array[16];
      int i;

      for (i = 0; i < 16; i++)
        array[i] = PyFloat_AsDouble (PyTuple_GetItem (py_array, i));

      cogl_matrix_init_from_array (&self->matrix, array);
    }

  return 0;
}

static PyObject *
pycogl_matrix_from_matrix (CoglMatrix *matrix)
{
  PyCoglMatrix *self;
  PyTypeObject *type = &PyCoglMatrix_Type;

  self = (PyCoglMatrix *)type->tp_alloc(type, 0);
  self->matrix = *matrix;

  return (PyObject *)self;
}

static PyObject *
pycogl_matrix_init_identity (PyCoglMatrix *self)
{
  cogl_matrix_init_identity (&self->matrix);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_matrix_init_from_array (PyCoglMatrix *self, PyObject *args)
{
  PyObject *py_array;
  float array[16];
  int i;

  if (!PyArg_ParseTuple (args, "O:cogl.Matrix.init_from_array",
                         &py_array))
    return NULL;

  if (!PyTuple_Check (py_array) || PyTuple_Size (py_array) != 16)
    {
      PyErr_SetString (PyExc_ValueError,
                       "array must be a tuple of 16 floats");
      return NULL;
    }

  for (i = 0; i < 16; i++)
    array[i] = PyFloat_AsDouble (PyTuple_GetItem (py_array, i));

  cogl_matrix_init_from_array (&self->matrix, array);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_matrix_frustum (PyCoglMatrix *self, PyObject *args)
{
  float left, right, bottom, top, z_near, z_far;

  if (!PyArg_ParseTuple (args, "ffffff:cogl.Matrix.frustum",
                         &left, &right, &bottom, &top, &z_near, &z_far))
    return NULL;

  cogl_matrix_frustum (&self->matrix, left, right, bottom, top, z_near, z_far);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_matrix_ortho (PyCoglMatrix *self, PyObject *args)
{
  float left, right, bottom, top, z_near, z_far;

  if (!PyArg_ParseTuple (args, "ffffff:cogl.Matrix.ortho",
                         &left, &right, &bottom, &top, &z_near, &z_far))
    return NULL;

  cogl_matrix_ortho (&self->matrix, left, right, bottom, top, z_near, z_far);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_matrix_perspective (PyCoglMatrix *self, PyObject *args)
{
  float fov_y, aspect, z_near, z_far;

  if (!PyArg_ParseTuple (args, "ffff:cogl.Matrix.perspective",
                         &fov_y, &aspect, &z_near, &z_far))
    return NULL;

  cogl_matrix_perspective (&self->matrix, fov_y, aspect, z_near, z_far);

  Py_INCREF (Py_None);
  return Py_None;
}

/* FIXME: pycogl_matrix_transform_point */

static PyObject *
pycogl_matrix_multiply (PyCoglMatrix *self, PyObject *args)
{
  PyCoglMatrix *a, *b;

  if (!PyArg_ParseTuple (args, "O!O!:cogl.Matrix.multiply",
                         &PyCoglMatrix_Type, &a,
                         &PyCoglMatrix_Type, &b))
    return NULL;

  cogl_matrix_multiply (&self->matrix, &a->matrix, &b->matrix);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_matrix_rotate (PyCoglMatrix *self, PyObject *args)
{
  float angle, x, y, z;

  if (!PyArg_ParseTuple (args, "ffff:cogl.Matrix.rotate",
                         &angle, &x, &y, &z))
    return NULL;

  cogl_matrix_rotate (&self->matrix, angle, x, y, z);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_matrix_translate (PyCoglMatrix *self, PyObject *args)
{
  float x, y, z;

  if (!PyArg_ParseTuple (args, "fff:cogl.Matrix.translate",
                         &x, &y, &z))
    return NULL;

  cogl_matrix_translate (&self->matrix, x, y, z);

  Py_INCREF (Py_None);
  return Py_None;
}

static PyObject *
pycogl_matrix_scale (PyCoglMatrix *self, PyObject *args)
{
  float sx, sy, sz;

  if (!PyArg_ParseTuple (args, "fff:cogl.Matrix.scale",
                         &sx, &sy, &sz))
    return NULL;

  cogl_matrix_scale (&self->matrix, sx, sy, sz);

  Py_INCREF (Py_None);
  return Py_None;
}

/* TODO: This should be done a more pythonic way :) */
static PyObject *
pycogl_matrix_get_array (PyCoglMatrix *self)
{
  const float *array;
  PyObject *py_array;
  int i;

  array = cogl_matrix_get_array (&self->matrix);
  py_array = PyTuple_New (16);

  for (i = 0; i < 16; i++)
    PyTuple_SetItem (py_array, i, PyFloat_FromDouble (array[i]));

  return py_array;
}

static PyObject *
pycogl_matrix_get_inverse (PyCoglMatrix *self)
{
  CoglMatrix inverse;

  if (!cogl_matrix_get_inverse (&self->matrix, &inverse))
    {
      PyErr_SetString (PyExc_ValueError, "Can't get inverse matrix");
      return NULL;
    }

  return pycogl_matrix_from_matrix (&inverse);
}

static PyMethodDef pycogl_matrix_methods[] = {
    { "init_identity", (PyCFunction)pycogl_matrix_init_identity, METH_NOARGS },
    { "init_from_array", (PyCFunction)pycogl_matrix_init_from_array, METH_VARARGS },
    { "frustum", (PyCFunction)pycogl_matrix_frustum, METH_VARARGS },
    { "ortho", (PyCFunction)pycogl_matrix_ortho, METH_VARARGS },
    { "perspective", (PyCFunction)pycogl_matrix_perspective, METH_VARARGS },
    { "multiply", (PyCFunction)pycogl_matrix_multiply, METH_VARARGS },
    { "rotate", (PyCFunction)pycogl_matrix_rotate, METH_VARARGS },
    { "translate", (PyCFunction)pycogl_matrix_translate, METH_VARARGS },
    { "scale", (PyCFunction)pycogl_matrix_scale, METH_VARARGS },
    { "get_array", (PyCFunction)pycogl_matrix_get_array, METH_NOARGS },
    { "get_inverse", (PyCFunction)pycogl_matrix_get_inverse, METH_NOARGS },
    { NULL, NULL, 0, NULL },
};

PyTypeObject PyCoglMatrix_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                  /* ob_size */
    "cogl.Matrix",                      /* tp_name */
    sizeof(PyCoglMatrix),               /* tp_basicsize */
    0,                                  /* tp_itemsize */
    0,                                  /* tp_dealloc */
    0,                                  /* tp_print */
    0,                                  /* tp_getattr */
    0,                                  /* tp_setattr */
    0,                                  /* tp_compare */
    0,                                  /* tp_repr */
    0,                                  /* tp_as_number */
    0,                                  /* tp_as_sequence */
    0,                                  /* tp_as_mapping */
    0,                                  /* tp_hash */
    0,                                  /* tp_call */
    0,                                  /* tp_str */
    0,                                  /* tp_getattro */
    0,                                  /* tp_setattro */
    0,                                  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    0,                                  /* tp_doc */
    0,                                  /* tp_traverse */
    0,                                  /* tp_clear */
    0,                                  /* tp_richcompare */
    0,                                  /* tp_weaklistoffset */
    0,                                  /* tp_iter */
    0,                                  /* tp_iternext */
    pycogl_matrix_methods,              /* tp_methods */
    0,                                  /* tp_members */
    0,                                  /* tp_getset */
    0, /* &PyCoglHandle_Type, */        /* tp_base */
    0,                                  /* tp_dict */
    0,                                  /* tp_descr_get */
    0,                                  /* tp_descr_set */
    0,                                  /* tp_dictoffset */
    (initproc)pycogl_matrix_init,       /* tp_init */
    0,                                  /* tp_alloc */
    (newfunc)pycogl_matrix_new,         /* tp_new */
    0,                                  /* tp_free */
    0,                                  /* tp_is_gc */
    0,                                  /* tp_bases */
};

#line 7 "cogl-offscreen.override"

static PyObject *
pycogl_offscreen_new (PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
  PyCoglTexture *texture;
  CoglHandle handle;

  if (!PyArg_ParseTuple (args, "O!:cogl.Offscreen",
                         &PyCoglTexture_Type, &texture))
    return NULL;

  handle = cogl_offscreen_new_to_texture (texture->handle);

  return pycogl_handle_from_handle_without_ref (handle);
}


static PyMethodDef pycogl_offscreen_methods[] = {
    { NULL, NULL, 0, NULL },
};


PyTypeObject PyCoglOffscreen_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                  /* ob_size */
    "cogl.Offscreen",                   /* tp_name */
    sizeof(PyCoglOffscreen),            /* tp_basicsize */
    0,                                  /* tp_itemsize */
    (destructor)pycogl_handle_dealloc,  /* tp_dealloc */
    0,                                  /* tp_print */
    0,                                  /* tp_getattr */
    0,                                  /* tp_setattr */
    0,                                  /* tp_compare */
    0,                                  /* tp_repr */
    0,                                  /* tp_as_number */
    0,                                  /* tp_as_sequence */
    0,                                  /* tp_as_mapping */
    0,                                  /* tp_hash */
    0,                                  /* tp_call */
    0,                                  /* tp_str */
    0,                                  /* tp_getattro */
    0,                                  /* tp_setattro */
    0,                                  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT,                 /* tp_flags */
    0,                                  /* tp_doc */
    0,                                  /* tp_traverse */
    0,                                  /* tp_clear */
    0,                                  /* tp_richcompare */
    0,                                  /* tp_weaklistoffset */
    0,                                  /* tp_iter */
    0,                                  /* tp_iternext */
    pycogl_offscreen_methods,           /* tp_methods */
    0,                                  /* tp_members */
    0,                                  /* tp_getset */
    0, /* &PyCoglHandle_Type, */        /* tp_base */
    0,                                  /* tp_dict */
    0,                                  /* tp_descr_get */
    0,                                  /* tp_descr_set */
    0,                                  /* tp_dictoffset */
    0,                                  /* tp_init */
    0,                                  /* tp_alloc */
    (newfunc)pycogl_offscreen_new,      /* tp_new */
    0,                                  /* tp_free */
    0,                                  /* tp_is_gc */
    0,                                  /* tp_bases */
};
#line 1481 "cogl.c"



/* ----------- CoglPangoFontMap ----------- */

#line 232 "./cogl.override"
static int
_wrap_cogl_pango_font_map_new (PyGObject *self)
{
  self->obj = (GObject *) cogl_pango_font_map_new ();
  if (!self->obj)
    {
      PyErr_SetString (PyExc_RuntimeError, "could not create PangoFontMap");
      return -1;
    }

  g_object_ref (self->obj);
  pygobject_register_wrapper ((PyObject *) self);

  return 0;
}
#line 1503 "cogl.c"


static PyObject *
_wrap_cogl_pango_font_map_create_context(PyGObject *self)
{
    PangoContext *ret;

    
    ret = cogl_pango_font_map_create_context(COGL_PANGO_FONT_MAP(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_cogl_pango_font_map_set_resolution(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dpi", NULL };
    double dpi;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"d:Cogl.PangoFontMap.set_resolution", kwlist, &dpi))
        return NULL;
    
    cogl_pango_font_map_set_resolution(COGL_PANGO_FONT_MAP(self->obj), dpi);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_pango_font_map_clear_glyph_cache(PyGObject *self)
{
    
    cogl_pango_font_map_clear_glyph_cache(COGL_PANGO_FONT_MAP(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_pango_font_map_set_use_mipmapping(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "value", NULL };
    int value;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:Cogl.PangoFontMap.set_use_mipmapping", kwlist, &value))
        return NULL;
    
    cogl_pango_font_map_set_use_mipmapping(COGL_PANGO_FONT_MAP(self->obj), value);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_pango_font_map_get_use_mipmapping(PyGObject *self)
{
    int ret;

    
    ret = cogl_pango_font_map_get_use_mipmapping(COGL_PANGO_FONT_MAP(self->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_cogl_pango_font_map_get_renderer(PyGObject *self)
{
    PangoRenderer *ret;

    
    ret = cogl_pango_font_map_get_renderer(COGL_PANGO_FONT_MAP(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static const PyMethodDef _PyCoglPangoFontMap_methods[] = {
    { "create_context", (PyCFunction)_wrap_cogl_pango_font_map_create_context, METH_NOARGS,
      NULL },
    { "set_resolution", (PyCFunction)_wrap_cogl_pango_font_map_set_resolution, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "clear_glyph_cache", (PyCFunction)_wrap_cogl_pango_font_map_clear_glyph_cache, METH_NOARGS,
      NULL },
    { "set_use_mipmapping", (PyCFunction)_wrap_cogl_pango_font_map_set_use_mipmapping, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_use_mipmapping", (PyCFunction)_wrap_cogl_pango_font_map_get_use_mipmapping, METH_NOARGS,
      NULL },
    { "get_renderer", (PyCFunction)_wrap_cogl_pango_font_map_get_renderer, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyCoglPangoFontMap_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "clutter.cogl.PangoFontMap",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyCoglPangoFontMap_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_cogl_pango_font_map_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- functions ----------- */

#line 210 "./cogl.override"
static PyObject *
_wrap_cogl_bitmap_get_size_from_file (PyObject *self,
                                      PyObject *args,
                                      PyObject *kwargs)
{
    static char *kwlist[] = { "filename", NULL };
    const gchar *filename;
    gint width, height;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     "s:cogl.bitmap_get_size_from_file",
                                     kwlist, &filename))
        return NULL;
    
    cogl_bitmap_get_size_from_file (filename, &width, &height);

    return Py_BuildValue ("(ii)", width, height);
}
#line 1666 "cogl.c"


#line 493 "./cogl.override"
static PyObject *
_wrap_cogl_color_premultiply (PyObject *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.color_premultiply",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    {
      return NULL;
    }

  cogl_color_premultiply (&color);
  return pyobject_from_cogl_color (&color);
}
#line 1688 "cogl.c"


#line 470 "./cogl.override"
static PyObject *
_wrap_cogl_color_to_clutter_color (PyObject *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.color_to_clutter_color",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    return NULL;

  ClutterColor *dest = clutter_color_new (
                          (gint)(cogl_color_get_red (&color) * 255),
                          (gint)(cogl_color_get_green (&color) * 255),
                          (gint)(cogl_color_get_blue (&color) * 255),
                          (gint)(cogl_color_get_alpha (&color) * 255));

  return pyg_boxed_new (CLUTTER_TYPE_COLOR, dest, TRUE, TRUE);
}
#line 1713 "cogl.c"


static PyObject *
_wrap_cogl_shader_type_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_shader_type_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_pixel_format_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_pixel_format_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_feature_flags_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_feature_flags_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_buffer_target_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_buffer_target_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_texture_flags_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_texture_flags_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_fog_mode_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_fog_mode_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_attribute_type_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_attribute_type_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_vertices_mode_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_vertices_mode_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_indices_type_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_indices_type_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_buffer_bit_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_buffer_bit_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_read_pixels_flags_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_read_pixels_flags_get_type();
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_cogl_sqrti(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", NULL };
    int x, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:sqrti", kwlist, &x))
        return NULL;
    
    ret = cogl_sqrti(x);
    
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_cogl_get_features(PyObject *self)
{
    guint ret;

    
    ret = cogl_get_features();
    
    return pyg_flags_from_gtype(COGL_TYPE_FEATURE_FLAGS, ret);
}

static PyObject *
_wrap_cogl_features_available(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "features", NULL };
    CoglFeatureFlags features;
    PyObject *py_features = NULL;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:features_available", kwlist, &py_features))
        return NULL;
    if (pyg_flags_get_value(COGL_TYPE_FEATURE_FLAGS, py_features, (gpointer)&features))
        return NULL;
    
    ret = cogl_features_available(features);
    
    return PyBool_FromLong(ret);

}

#line 199 "./cogl.override"
static PyObject *
_wrap_cogl_get_bitmasks (PyObject *self)
{
  gint red, green, blue, alpha;

  cogl_get_bitmasks (&red, &green, &blue, &alpha);

  return Py_BuildValue ("(iiii)", red, green, blue, alpha);
}
#line 1891 "cogl.c"


static PyObject *
_wrap_cogl_perspective(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "fovy", "aspect", "z_near", "z_far", NULL };
    double fovy, aspect, z_near, z_far;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddd:perspective", kwlist, &fovy, &aspect, &z_near, &z_far))
        return NULL;
    
    cogl_perspective(fovy, aspect, z_near, z_far);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_frustum(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "left", "right", "bottom", "top", "z_near", "z_far", NULL };
    double left, right, bottom, top, z_near, z_far;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddddd:frustum", kwlist, &left, &right, &bottom, &top, &z_near, &z_far))
        return NULL;
    
    cogl_frustum(left, right, bottom, top, z_near, z_far);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_ortho(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "left", "right", "bottom", "top", "near", "far", NULL };
    double left, right, bottom, top, near, far;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddddd:ortho", kwlist, &left, &right, &bottom, &top, &near, &far))
        return NULL;
    
    cogl_ortho(left, right, bottom, top, near, far);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_push_matrix(PyObject *self)
{
    
    cogl_push_matrix();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_pop_matrix(PyObject *self)
{
    
    cogl_pop_matrix();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_scale(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", "z", NULL };
    double x, y, z;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ddd:scale", kwlist, &x, &y, &z))
        return NULL;
    
    cogl_scale(x, y, z);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_translate(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", "z", NULL };
    double x, y, z;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ddd:translate", kwlist, &x, &y, &z))
        return NULL;
    
    cogl_translate(x, y, z);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_rotate(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "angle", "x", "y", "z", NULL };
    double angle, x, y, z;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddd:rotate", kwlist, &angle, &x, &y, &z))
        return NULL;
    
    cogl_rotate(angle, x, y, z);
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 416 "./cogl.override"
static PyObject *
_wrap_cogl_get_modelview_matrix (PyObject *self)
{
    CoglMatrix matrix;

    cogl_get_modelview_matrix (&matrix);

    return pycogl_matrix_from_matrix (&matrix);
}
#line 2014 "cogl.c"


#line 427 "./cogl.override"
static PyObject *
_wrap_cogl_set_modelview_matrix (PyObject *self, PyObject *args)
{
  PyCoglMatrix *py_matrix;

  if (!PyArg_ParseTuple (args, "O!:cogl.set_modelview_matrix",
                         &PyCoglMatrix_Type, &py_matrix))
    return NULL;

  cogl_set_modelview_matrix (&py_matrix->matrix);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 2032 "cogl.c"


#line 443 "./cogl.override"
static PyObject *
_wrap_cogl_get_projection_matrix (PyObject *self)
{
    CoglMatrix matrix;

    cogl_get_projection_matrix (&matrix);

    return pycogl_matrix_from_matrix (&matrix);
}
#line 2045 "cogl.c"


#line 454 "./cogl.override"
static PyObject *
_wrap_cogl_set_projection_matrix (PyObject *self, PyObject *args)
{
  PyCoglMatrix *py_matrix;

  if (!PyArg_ParseTuple (args, "O!:cogl.set_projection_matrix",
                         &PyCoglMatrix_Type, &py_matrix))
    return NULL;

  cogl_set_projection_matrix (&py_matrix->matrix);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 2063 "cogl.c"


#line 184 "./cogl.override"
static PyObject *
_wrap_cogl_get_viewport (PyObject *self)
{
  float viewport[4] = { 0, };

  cogl_get_viewport (viewport);

  return Py_BuildValue ("(ffff)",
                        viewport[0],
                        viewport[1],
                        viewport[2],
                        viewport[3]);
}
#line 2080 "cogl.c"


static PyObject *
_wrap_cogl_set_depth_test_enabled(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "setting", NULL };
    int setting;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:set_depth_test_enabled", kwlist, &setting))
        return NULL;
    
    cogl_set_depth_test_enabled(setting);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_get_depth_test_enabled(PyObject *self)
{
    int ret;

    
    ret = cogl_get_depth_test_enabled();
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_cogl_set_backface_culling_enabled(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "setting", NULL };
    int setting;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:set_backface_culling_enabled", kwlist, &setting))
        return NULL;
    
    cogl_set_backface_culling_enabled(setting);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_get_backface_culling_enabled(PyObject *self)
{
    int ret;

    
    ret = cogl_get_backface_culling_enabled();
    
    return PyBool_FromLong(ret);

}

#line 356 "./cogl.override"
static PyObject *
_wrap_cogl_set_fog(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "fog_color", "mode", "density", "z_near", "z_far", NULL };
    CoglColor fog_color;
    PyObject *py_fog_color, *py_mode = NULL;
    double density, z_near, z_far;
    CoglFogMode mode;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     "OOddd:set_fog",
                                     kwlist,
                                     &py_fog_color, &py_mode,
                                     &density, &z_near, &z_far))
        return NULL;

    if (!pycogl_color_from_pyobject (py_fog_color, &fog_color))
    {
        PyErr_Clear ();
        PyErr_SetString (PyExc_TypeError,
                         "color must be a ClutterColor or 4-tuple");
        return NULL;
    }

    if (pyg_enum_get_value(COGL_TYPE_FOG_MODE, py_mode, (gpointer)&mode))
        return NULL;
    
    cogl_set_fog(&fog_color, mode, density, z_near, z_far);
    
    Py_INCREF(Py_None);
    return Py_None;
}
#line 2170 "cogl.c"


static PyObject *
_wrap_cogl_disable_fog(PyObject *self)
{
    
    cogl_disable_fog();
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 390 "./cogl.override"
static PyObject *
_wrap_cogl_clear(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", "buffers", NULL };
    CoglColor color;
    PyObject *py_color;
    unsigned long buffers;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"Ok:clear", kwlist, &py_color, &buffers))
        return NULL;

    if (!pycogl_color_from_pyobject (py_color, &color))
    {
        PyErr_Clear ();
        PyErr_SetString (PyExc_TypeError,
                         "color must be a ClutterColor or 4-tuple");
        return NULL;
    }

    cogl_clear(&color, buffers);
    
    Py_INCREF(Py_None);
    return Py_None;
}
#line 2208 "cogl.c"


#line 513 "./cogl.override"
static PyObject *
_wrap_cogl_set_source (PyObject *self, PyObject *args)
{
  PyCoglMaterial *material;

  if (!PyArg_ParseTuple (args, "O!:cogl.set_source",
                         &PyCoglMaterial_Type, &material))
    return NULL;

  cogl_set_source (material->handle);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 2226 "cogl.c"


#line 529 "./cogl.override"
static PyObject *
_wrap_cogl_set_source_color (PyObject *self, PyObject *args)
{
  PyObject *py_color;
  CoglColor color;

  if (!PyArg_ParseTuple (args, "O:cogl.set_source_color",
                         &py_color))
    return NULL;

  if (!pycogl_color_from_pyobject (py_color, &color))
    return NULL;

  cogl_set_source_color (&color);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 2248 "cogl.c"


static PyObject *
_wrap_cogl_set_source_color4ub(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "red", "green", "blue", "alpha", NULL };
    int red, green, blue, alpha;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"iiii:set_source_color4ub", kwlist, &red, &green, &blue, &alpha))
        return NULL;
    
    cogl_set_source_color4ub(red, green, blue, alpha);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_set_source_color4f(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "red", "green", "blue", "alpha", NULL };
    double red, green, blue, alpha;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddd:set_source_color4f", kwlist, &red, &green, &blue, &alpha))
        return NULL;
    
    cogl_set_source_color4f(red, green, blue, alpha);
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 549 "./cogl.override"
static PyObject *
_wrap_cogl_set_source_texture (PyObject *self, PyObject *args)
{
  PyCoglTexture *texture;

  if (!PyArg_ParseTuple (args, "O!:cogl.set_source_texture",
                         &PyCoglTexture_Type, &texture))
    return NULL;

  cogl_set_source_texture (texture->handle);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 2296 "cogl.c"


static PyObject *
_wrap_cogl_clip_push_from_path(PyObject *self)
{
    
    cogl_clip_push_from_path();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_clip_push_from_path_preserve(PyObject *self)
{
    
    cogl_clip_push_from_path_preserve();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_clip_pop(PyObject *self)
{
    
    cogl_clip_pop();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_flush(PyObject *self)
{
    
    cogl_flush();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_begin_gl(PyObject *self)
{
    
    cogl_begin_gl();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_end_gl(PyObject *self)
{
    
    cogl_end_gl();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_set_viewport(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", "width", "height", NULL };
    int x, y, width, height;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"iiii:set_viewport", kwlist, &x, &y, &width, &height))
        return NULL;
    
    cogl_set_viewport(x, y, width, height);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_clip_push_window_rectangle(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x_offset", "y_offset", "width", "height", NULL };
    int x_offset, y_offset, width, height;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"iiii:clip_push_window_rectangle", kwlist, &x_offset, &y_offset, &width, &height))
        return NULL;
    
    cogl_clip_push_window_rectangle(x_offset, y_offset, width, height);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_clip_push_rectangle(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x0", "y0", "x1", "y1", NULL };
    double x0, y0, x1, y1;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddd:clip_push_rectangle", kwlist, &x0, &y0, &x1, &y1))
        return NULL;
    
    cogl_clip_push_rectangle(x0, y0, x1, y1);
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 635 "./cogl.override"
static PyObject *
_wrap_cogl_set_framebuffer (PyGObject    *self,
                            PyCoglHandle *py_handle)
{
  cogl_set_framebuffer (py_handle->handle);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 2414 "cogl.c"


#line 646 "./cogl.override"
static PyObject *
_wrap_cogl_push_framebuffer (PyGObject    *self,
                            PyCoglHandle *py_handle)
{
  cogl_push_framebuffer (py_handle->handle);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 2427 "cogl.c"


static PyObject *
_wrap_cogl_pop_framebuffer(PyObject *self)
{
    
    cogl_pop_framebuffer();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_pango_ensure_glyph_cache_for_layout(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "layout", NULL };
    PyGObject *layout;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:pango_ensure_glyph_cache_for_layout", kwlist, &PyPangoLayout_Type, &layout))
        return NULL;
    
    cogl_pango_ensure_glyph_cache_for_layout(PANGO_LAYOUT(layout->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_pango_renderer_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_pango_renderer_get_type();
    
    return pyg_type_wrapper_new(ret);
}

#line 284 "./cogl.override"
static PyObject *
_wrap_cogl_pango_render_layout_subpixel(PyObject *self,
                                        PyObject *args,
                                        PyObject *kwargs)
{
    static char *kwlist[] = { "layout", "x", "y", "color", "flags", NULL };
    PyGObject *layout;
    int x, y, flags;
    CoglColor color;
    PyObject *py_color;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     "O!iiOi:pango_render_layout_subpixel",
                                     kwlist,
                                     &PyPangoLayout_Type,
                                     &layout,
                                     &x, &y, &py_color, &flags))
        return NULL;

    if (!pycogl_color_from_pyobject (py_color, &color))
    {
        PyErr_Clear ();
        PyErr_SetString (PyExc_TypeError,
                         "color must be a ClutterColor or 4-tuple");
        return NULL;
    }

    
    cogl_pango_render_layout_subpixel(PANGO_LAYOUT(layout->obj), x, y, &color, flags);
    
    Py_INCREF(Py_None);
    return Py_None;
}
#line 2500 "cogl.c"


#line 249 "./cogl.override"
static PyObject *
_wrap_cogl_pango_render_layout(PyObject *self,
                               PyObject *args,
                               PyObject *kwargs)
{
    static char *kwlist[] = { "layout", "x", "y", "color", "flags", NULL };
    PyGObject *layout;
    int x, y, flags;
    CoglColor color;
    PyObject *py_color;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     "O!iiOi:pango_render_layout",
                                     kwlist,
                                     &PyPangoLayout_Type,
                                     &layout,
                                     &x, &y, &py_color, &flags))
        return NULL;

    if (!pycogl_color_from_pyobject (py_color, &color))
    {
        PyErr_Clear ();
        PyErr_SetString (PyExc_TypeError,
                         "color must be a ClutterColor or 4-tuple");
        return NULL;
    }

    
    cogl_pango_render_layout(PANGO_LAYOUT(layout->obj), x, y, &color, flags);
    
    Py_INCREF(Py_None);
    return Py_None;
}
#line 2537 "cogl.c"


#line 319 "./cogl.override"
static PyObject *
_wrap_cogl_pango_render_layout_line(PyObject *self,
                                    PyObject *args,
                                    PyObject *kwargs)
{
    static char *kwlist[] = { "line", "x", "y", "color", NULL };
    PangoLayoutLine *line = NULL;
    PyObject *py_line, *py_color;
    int x, y;
    CoglColor color;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     "OiiO:pango_render_layout_line",
                                     kwlist, &py_line, &x, &y, &py_color))
        return NULL;
    if (pyg_boxed_check(py_line, PANGO_TYPE_LAYOUT_LINE))
        line = pyg_boxed_get(py_line, PangoLayoutLine);
    else {
        PyErr_SetString(PyExc_TypeError, "line should be a PangoLayoutLine");
        return NULL;
    }
    
    if (!pycogl_color_from_pyobject (py_color, &color))
    {
        PyErr_Clear ();
        PyErr_SetString (PyExc_TypeError,
                         "color must be a ClutterColor or 4-tuple");
        return NULL;
    }

    cogl_pango_render_layout_line(line, x, y, &color);
    
    Py_INCREF(Py_None);
    return Py_None;
}
#line 2576 "cogl.c"


static PyObject *
_wrap_cogl_rectangle(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x_1", "y_1", "x_2", "y_2", NULL };
    double x_1, y_1, x_2, y_2;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddd:rectangle", kwlist, &x_1, &y_1, &x_2, &y_2))
        return NULL;
    
    cogl_rectangle(x_1, y_1, x_2, y_2);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_fill(PyObject *self)
{
    
    cogl_path_fill();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_fill_preserve(PyObject *self)
{
    
    cogl_path_fill_preserve();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_stroke(PyObject *self)
{
    
    cogl_path_stroke();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_stroke_preserve(PyObject *self)
{
    
    cogl_path_stroke_preserve();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_new(PyObject *self)
{
    
    cogl_path_new();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_move_to(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", NULL };
    double x, y;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dd:path_move_to", kwlist, &x, &y))
        return NULL;
    
    cogl_path_move_to(x, y);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_rel_move_to(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", NULL };
    double x, y;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dd:path_rel_move_to", kwlist, &x, &y))
        return NULL;
    
    cogl_path_rel_move_to(x, y);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_line_to(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", NULL };
    double x, y;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dd:path_line_to", kwlist, &x, &y))
        return NULL;
    
    cogl_path_line_to(x, y);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_rel_line_to(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", NULL };
    double x, y;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dd:path_rel_line_to", kwlist, &x, &y))
        return NULL;
    
    cogl_path_rel_line_to(x, y);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_arc(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "center_x", "center_y", "radius_x", "radius_y", "angle_1", "angle_2", NULL };
    double center_x, center_y, radius_x, radius_y, angle_1, angle_2;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddddd:path_arc", kwlist, &center_x, &center_y, &radius_x, &radius_y, &angle_1, &angle_2))
        return NULL;
    
    cogl_path_arc(center_x, center_y, radius_x, radius_y, angle_1, angle_2);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_curve_to(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x_1", "y_1", "x_2", "y_2", "x_3", "y_3", NULL };
    double x_1, y_1, x_2, y_2, x_3, y_3;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddddd:path_curve_to", kwlist, &x_1, &y_1, &x_2, &y_2, &x_3, &y_3))
        return NULL;
    
    cogl_path_curve_to(x_1, y_1, x_2, y_2, x_3, y_3);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_rel_curve_to(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x_1", "y_1", "x_2", "y_2", "x_3", "y_3", NULL };
    double x_1, y_1, x_2, y_2, x_3, y_3;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddddd:path_rel_curve_to", kwlist, &x_1, &y_1, &x_2, &y_2, &x_3, &y_3))
        return NULL;
    
    cogl_path_rel_curve_to(x_1, y_1, x_2, y_2, x_3, y_3);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_close(PyObject *self)
{
    
    cogl_path_close();
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_line(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x_1", "y_1", "x_2", "y_2", NULL };
    double x_1, y_1, x_2, y_2;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddd:path_line", kwlist, &x_1, &y_1, &x_2, &y_2))
        return NULL;
    
    cogl_path_line(x_1, y_1, x_2, y_2);
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 565 "./cogl.override"
static PyObject *
_wrap_cogl_path_polyline (PyObject *self, PyObject *args)
{
  gint len = PyTuple_Size (args);
  gfloat coords[len];
  gint i;

  if (len < 2 || (len % 2 != 0))
    {
      PyErr_SetString (PyExc_TypeError,
                       "cogl.path_polyline requires at least two values");
      return NULL;
    }

  for (i = 0; i < len; i++)
    coords[i] = PyFloat_AsDouble (PyTuple_GetItem (args, i));

  cogl_path_polyline (coords, len);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 2797 "cogl.c"


#line 589 "./cogl.override"
static PyObject *
_wrap_cogl_path_polygon (PyObject *self, PyObject *args)
{
  gint len = PyTuple_Size (args);
  gfloat coords[len];
  gint i;

  if (len < 2 || (len % 2 != 0))
    {
      PyErr_SetString (PyExc_TypeError,
                       "cogl.path_polygon requires at least two values");
      return NULL;
    }

  for (i = 0; i < len; i++)
    coords[i] = PyFloat_AsDouble (PyTuple_GetItem (args, i));

  cogl_path_polygon (coords, len);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 2823 "cogl.c"


static PyObject *
_wrap_cogl_path_rectangle(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x_1", "y_1", "x_2", "y_2", NULL };
    double x_1, y_1, x_2, y_2;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddd:path_rectangle", kwlist, &x_1, &y_1, &x_2, &y_2))
        return NULL;
    
    cogl_path_rectangle(x_1, y_1, x_2, y_2);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_ellipse(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "center_x", "center_y", "radius_x", "radius_y", NULL };
    double center_x, center_y, radius_x, radius_y;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddd:path_ellipse", kwlist, &center_x, &center_y, &radius_x, &radius_y))
        return NULL;
    
    cogl_path_ellipse(center_x, center_y, radius_x, radius_y);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_cogl_path_round_rectangle(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x_1", "y_1", "x_2", "y_2", "radius", "arc_step", NULL };
    double x_1, y_1, x_2, y_2, radius, arc_step;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"dddddd:path_round_rectangle", kwlist, &x_1, &y_1, &x_2, &y_2, &radius, &arc_step))
        return NULL;
    
    cogl_path_round_rectangle(x_1, y_1, x_2, y_2, radius, arc_step);
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 198 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_with_size (PyObject *self,
                                  PyObject *args,
                                  PyObject *kwargs)
{
  static char *kwlist[] = { "width", "height", "flags", "format", NULL };
  guint width, height;
  PyObject *py_flags = NULL, *py_format = NULL;
  CoglTextureFlags flags = COGL_TEXTURE_NONE;
  CoglPixelFormat format = COGL_PIXEL_FORMAT_ANY;
  CoglHandle handle = COGL_INVALID_HANDLE;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "ii|OO:cogl.texture_new_with_size",
                                    kwlist, &width, &height,
                                    &py_flags, &py_format))
    return NULL;

  if (py_flags && pyg_flags_get_value (COGL_TYPE_TEXTURE_FLAGS, py_flags,
                           (gpointer)&flags))
    return NULL;

  if (py_format && pyg_enum_get_value (COGL_TYPE_PIXEL_FORMAT, py_format,
                          (gpointer)&format))
    return NULL;

  handle = cogl_texture_new_with_size (width, height, flags, format);

  return pycogl_handle_from_handle_without_ref (handle);
}

#line 2903 "cogl.c"


#line 231 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_from_file (PyObject *self,
                                  PyObject *args,
                                  PyObject *kwargs)
{
  static char *kwlist[] = { "filename", "flags", "format", NULL };
  const gchar *filename;
  PyObject *py_flags = NULL, *py_format = NULL;
  CoglTextureFlags flags = COGL_TEXTURE_NONE;
  CoglPixelFormat format = COGL_PIXEL_FORMAT_ANY;
  GError *error = NULL;
  CoglHandle handle = COGL_INVALID_HANDLE;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "s|OO:cogl.texture_new_from_file",
                                    kwlist, &filename, &py_flags, &py_format))
    return NULL;

  if (py_flags && pyg_flags_get_value (COGL_TYPE_TEXTURE_FLAGS, py_flags,
                           (gpointer)&flags))
    return NULL;

  if (py_format && pyg_enum_get_value (COGL_TYPE_PIXEL_FORMAT, py_format,
                          (gpointer)&format))
    return NULL;

  handle = cogl_texture_new_from_file (filename, flags, format, &error);

  if (error)
    {
      PyErr_Format (PyExc_RuntimeError, "%s", error->message);
      g_error_free (error);
      return NULL;
    }

  return pycogl_handle_from_handle_without_ref (handle);
}

#line 2945 "cogl.c"


#line 271 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_from_data (PyObject *self,
                                  PyObject *args,
                                  PyObject *kwargs)
{
  static char *kwlist[] = { "width", "height", "internal_format", "rowstride",
      "data", "flags", "format", NULL };
  guint width, height, rowstride;
  PyObject *py_flags = NULL, *py_format = NULL, *py_internal_format;
  CoglTextureFlags flags = COGL_TEXTURE_NONE;
  CoglPixelFormat format = COGL_PIXEL_FORMAT_ANY, internal_format;
  const guchar *data;
  gint size;
  CoglHandle handle = COGL_INVALID_HANDLE;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "iiOis#|OO:cogl.texture_new_from_data",
                                    kwlist,
                                    &width, &height, &py_internal_format,
                                    &rowstride, &data, &size, &py_flags,
                                    &py_format))
    return NULL;

  if (py_flags && pyg_flags_get_value (COGL_TYPE_TEXTURE_FLAGS, py_flags,
                           (gpointer)&flags))
    return NULL;

  if (py_format && pyg_enum_get_value (COGL_TYPE_PIXEL_FORMAT, py_format,
                          (gpointer)&format))
    return NULL;

  if (pyg_enum_get_value (COGL_TYPE_PIXEL_FORMAT, py_internal_format,
                          (gpointer)&internal_format))
    return NULL;

  handle = cogl_texture_new_from_data (width, height, flags, format,
                                       internal_format, rowstride, data);

  return pycogl_handle_from_handle_without_ref (handle);
}

#line 2990 "cogl.c"


#line 314 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_from_foreign (PyObject *self,
                                     PyObject *args,
                                     PyObject *kwargs)
{
  static char *kwlist[] = { "gl_handle", "gl_target", "width", "height",
      "x_pot_waste", "y_pot_waste", "format", NULL };
  GLuint gl_handle, width, height, x_pot_waste, y_pot_waste;
  GLenum gl_target;
  PyObject *py_format;
  CoglPixelFormat format;
  CoglHandle handle = COGL_INVALID_HANDLE;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "iiiiiiO:cogl.texture_new_from_foreign",
                                    kwlist,
                                    &gl_handle, &gl_target, &width, &height,
                                    &x_pot_waste, &y_pot_waste, &py_format))
    return NULL;

  if (pyg_enum_get_value (COGL_TYPE_PIXEL_FORMAT, py_format,
                          (gpointer)&format))
    return NULL;

  handle = cogl_texture_new_from_foreign (gl_handle, gl_target, width, height,
                                          x_pot_waste, y_pot_waste, format);

  return pycogl_handle_from_handle_without_ref (handle);
}

#line 3024 "cogl.c"


#line 346 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_from_bitmap (PyObject *self,
                                    PyObject *args,
                                    PyObject *kwargs)
{
  static char *kwlist[] = { "bmp_handle", "flags", "format", NULL };
  PyCoglHandle *bmp_handle;
  PyObject *py_flags = NULL, *py_format = NULL;
  CoglTextureFlags flags = COGL_TEXTURE_NONE;
  CoglPixelFormat format = COGL_PIXEL_FORMAT_ANY;
  CoglHandle handle = COGL_INVALID_HANDLE;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "O!|OO:cogl.texture_new_from_file",
                                    kwlist,
                                    &PyCoglHandle_Type, &bmp_handle,
                                    &py_flags, &py_format))
    return NULL;

  if (py_flags && pyg_flags_get_value (COGL_TYPE_TEXTURE_FLAGS, py_flags,
                           (gpointer)&flags))
    return NULL;

  if (py_format && pyg_enum_get_value (COGL_TYPE_PIXEL_FORMAT, py_format,
                          (gpointer)&format))
    return NULL;


  handle = cogl_texture_new_from_bitmap (bmp_handle->handle, flags, format);

  return pycogl_handle_from_handle_without_ref (handle);
}

#line 3061 "cogl.c"


#line 381 "cogl-texture.override"
static PyObject *
_wrap_cogl_rectangle_with_texture_coords (PyObject *self, PyObject *args)
{
  float x1, y1, x2, y2, tx1, ty1, tx2, ty2;

  if (!PyArg_ParseTuple (args, "ffffffff:cogl.rectangle_with_texture_coords",
                         &x1, &y1, &x2, &y2, &tx1, &ty1, &tx2, &ty2))
    return NULL;

  cogl_rectangle_with_texture_coords (x1, y1, x2, y2, tx1, ty1, tx2, ty2);

  Py_INCREF (Py_None);
  return Py_None;
}

#line 3080 "cogl.c"


#line 398 "cogl-texture.override"
static PyObject *
_wrap_cogl_rectangle_with_multitexture_coords (PyObject *self, PyObject *args)
{
  float x1, y1, x2, y2;
  gint tex_coords_len;
  PyObject *py_coords;

  if (!PyArg_ParseTuple (args, "ffffO:cogl.rectangle_with_multitexture_coords",
                         &x1, &y1, &x2, &y2, &py_coords))
    return NULL;

  if (!PyTuple_Check (py_coords))
    {
      PyErr_SetString (PyExc_TypeError, "tex_coords must be a tuple");
      return NULL;
    }

  tex_coords_len = PyTuple_Size (py_coords);
  gfloat tex_coords[tex_coords_len];
  gint i;

  for (i = 0; i < tex_coords_len; i++)
    tex_coords[i] = PyFloat_AsDouble (PyTuple_GetItem (py_coords, i));

  cogl_rectangle_with_multitexture_coords (x1, y1, x2, y2, tex_coords,
                                           tex_coords_len);

  Py_INCREF (Py_None);
  return Py_None;
}

#line 3115 "cogl.c"


#line 431 "cogl-texture.override"
static PyObject *
_wrap_cogl_rectangles_with_texture_coords (PyObject *self, PyObject *args)
{
  gint len = PyTuple_Size (args);
  gfloat verts[len*8];
  gint i, n;

  for (i=0, n=0; i < len; i++, n+=8)
    {
      PyObject *coords = PyTuple_GetItem (args, i);
      gfloat x1, y1, x2, y2, tx1, ty1, tx2, ty2;
      if (!PyTuple_Check (coords) ||
          !PyArg_ParseTuple (coords, "ffffffff",
                             &x1, &y1, &x2, &y2,
                             &tx1, &ty1, &tx2, &ty2))
        {
          PyErr_SetString (PyExc_ValueError,
                           "cogl.rectangles_with_texture_coords takes at "
                           "least one 8-tuple of floats");
          return NULL;
        }
      verts[n] = x1;
      verts[n+1] = y1;
      verts[n+2] = x2;
      verts[n+3] = y2;
      verts[n+4] = tx1;
      verts[n+5] = ty1;
      verts[n+6] = tx2;
      verts[n+7] = ty2;
    }

  cogl_rectangles_with_texture_coords (verts, len * 8);

  Py_INCREF (Py_None);
  return Py_None;
}

#line 3156 "cogl.c"


#line 470 "cogl-texture.override"
static PyObject *
_wrap_cogl_rectangles (PyObject *self, PyObject *args)
{
  gint len = PyTuple_Size (args);
  gfloat verts[len*4];
  gint i, n;

  for (i=0, n=0; i < len; i++, n+=4)
    {
      PyObject *coords = PyTuple_GetItem (args, i);
      gfloat x1, y1, x2, y2;
      if (!PyTuple_Check (coords) ||
          !PyArg_ParseTuple (coords, "ffff",
                             &x1, &y1, &x2, &y2))
        {
          PyErr_SetString (PyExc_ValueError,
                           "cogl.rectangles takes at least one 4-tuple "
                           "of floats");
          return NULL;
        }
      verts[n] = x1;
      verts[n+1] = y1;
      verts[n+2] = x2;
      verts[n+3] = y2;
    }

  cogl_rectangles (verts, len * 4);

  Py_INCREF (Py_None);
  return Py_None;
}

#line 3192 "cogl.c"


#line 504 "cogl-texture.override"
static PyObject *
_wrap_cogl_polygon (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "vertices", "use_color", NULL };
  PyObject *py_vertices;
  gboolean use_color;
  gint i, n_vertices;
  CoglTextureVertex *vertices = NULL;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "Oi:cogl.polygon", kwlist,
                                    &py_vertices, &use_color))
    return NULL;

  if (!PyTuple_Check (py_vertices))
    {
      PyErr_SetString (PyExc_TypeError, "vertices must be a tuple");
      return NULL;
    }

  n_vertices = PyTuple_Size (py_vertices);
  vertices = g_new (CoglTextureVertex, n_vertices);

  for (i = 0; i < n_vertices; i++)
    {
      PyObject *py_vertex, *py_color = NULL;
      py_vertex = PyTuple_GetItem (py_vertices, i);

      if (!PyTuple_Check (py_vertex) &&
          (PyTuple_Size (py_vertex) != 5 || PyTuple_Size (py_vertex) != 6))
        {
          PyErr_SetString (PyExc_TypeError,
                           "expecting a 5-tuple (x, y, z, tx, ty) or a "
                           "6-tuple (x, y, z, tx, ty, color)");
          g_free (vertices);
          return NULL;
        }

      if (!PyArg_ParseTuple (py_vertex, "fffff|O",
                             &(vertices[i].x),
                             &(vertices[i].y),
                             &(vertices[i].z),
                             &(vertices[i].tx),
                             &(vertices[i].ty),
                             &py_color))
        {
          g_free (vertices);
          return NULL;
        }

      if (py_color != NULL)
        {
          if (!pycogl_color_from_pyobject (py_color, &(vertices[i].color)))
            {
              g_free (vertices);
              return NULL;
            }
        }
    }

  cogl_polygon (vertices, n_vertices, use_color);
  g_free (vertices);

  Py_INCREF (Py_None);
  return Py_None;
}
#line 3262 "cogl.c"


#line 572 "cogl-texture.override"
static PyObject *
_wrap_cogl_texture_new_from_sub_texture (PyObject *self,
                                         PyObject *args,
                                         PyObject *kwargs)
{
  static char *kwlist[] = { "full_texture", "sub_x", "sub_y", "sub_width",
                            "sub_height", NULL };
  PyCoglTexture *py_full_texture;
  gint sub_x, sub_y, sub_width, sub_height;
  CoglHandle handle;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                    "O!iiii:cogl.texture_new_from_sub_texture",
                                    kwlist,
                                    &PyCoglTexture_Type, &py_full_texture,
                                    &sub_x, &sub_y, &sub_width, &sub_height))
    return NULL;

  handle = cogl_texture_new_from_sub_texture (py_full_texture->handle,
                                              sub_x, sub_y,
                                              sub_width, sub_height);

  return pycogl_handle_from_handle_without_ref (handle);
}
#line 3290 "cogl.c"


static PyObject *
_wrap_cogl_handle_get_type(PyObject *self)
{
    GType ret;

    
    ret = cogl_handle_get_type();
    
    return pyg_type_wrapper_new(ret);
}

const PyMethodDef pycogl_functions[] = {
    { "bitmap_get_size_from_file", (PyCFunction)_wrap_cogl_bitmap_get_size_from_file, METH_VARARGS|METH_KEYWORDS,
      (char *) "Parses an image file enough to extract the width and height of the\n"
"bitmap.\n" },
    { "color_premultiply", (PyCFunction)_wrap_cogl_color_premultiply, METH_VARARGS,
      NULL },
    { "color_to_clutter_color", (PyCFunction)_wrap_cogl_color_to_clutter_color, METH_VARARGS,
      NULL },
    { "shader_type_get_type", (PyCFunction)_wrap_cogl_shader_type_get_type, METH_NOARGS,
      NULL },
    { "pixel_format_get_type", (PyCFunction)_wrap_cogl_pixel_format_get_type, METH_NOARGS,
      NULL },
    { "feature_flags_get_type", (PyCFunction)_wrap_cogl_feature_flags_get_type, METH_NOARGS,
      NULL },
    { "buffer_target_get_type", (PyCFunction)_wrap_cogl_buffer_target_get_type, METH_NOARGS,
      NULL },
    { "texture_flags_get_type", (PyCFunction)_wrap_cogl_texture_flags_get_type, METH_NOARGS,
      NULL },
    { "fog_mode_get_type", (PyCFunction)_wrap_cogl_fog_mode_get_type, METH_NOARGS,
      NULL },
    { "attribute_type_get_type", (PyCFunction)_wrap_cogl_attribute_type_get_type, METH_NOARGS,
      NULL },
    { "vertices_mode_get_type", (PyCFunction)_wrap_cogl_vertices_mode_get_type, METH_NOARGS,
      NULL },
    { "indices_type_get_type", (PyCFunction)_wrap_cogl_indices_type_get_type, METH_NOARGS,
      NULL },
    { "buffer_bit_get_type", (PyCFunction)_wrap_cogl_buffer_bit_get_type, METH_NOARGS,
      NULL },
    { "read_pixels_flags_get_type", (PyCFunction)_wrap_cogl_read_pixels_flags_get_type, METH_NOARGS,
      (char *) "(only COGL_READ_PIXELS_COLOR_BUFFER supported currently) (only\n"
"COGL_PIXEL_FORMAT_RGBA_8888 supported currently) This reads a\n"
"rectangle of pixels from the current framebuffer where position (0, 0)\n"
"is the top left. The pixel at (x, y) is the first read, and the data\n"
"is returned with a rowstride of (width * 4). Currently Cogl assumes\n"
"that the framebuffer is in a premultiplied format so if format is non-\n"
"premultiplied it will convert it. To read the pixel values without any\n"
"conversion you should either specify a format that doesn't use an\n"
"alpha channel or use one of the formats ending in PRE.\n" },
    { "sqrti", (PyCFunction)_wrap_cogl_sqrti, METH_VARARGS|METH_KEYWORDS,
      (char *) "Very fast fixed point implementation of square root for integers. This\n"
"function is at least 6x faster than clib sqrt() on x86, and (this is\n"
"not a typo!) about 500x faster on ARM without FPU. It's error is less\n"
"than 5 for arguments smaller than COGL_SQRTI_ARG_5_PERCENT and less\n"
"than 10 for narguments smaller than COGL_SQRTI_ARG_10_PERCENT. The\n"
"maximum argument that can be passed to this function is\n"
"COGL_SQRTI_ARG_MAX.\n" },
    { "get_features", (PyCFunction)_wrap_cogl_get_features, METH_NOARGS,
      (char *) "Returns all of the features supported by COGL.\n" },
    { "features_available", (PyCFunction)_wrap_cogl_features_available, METH_VARARGS|METH_KEYWORDS,
      (char *) "Checks whether the given COGL features are available. Multiple\n"
"features can be checked for by or-ing them together with the '|'\n"
"operator. TRUE is only returned if all of the requested features are\n"
"available.\n" },
    { "get_bitmasks", (PyCFunction)_wrap_cogl_get_bitmasks, METH_NOARGS,
      (char *) "Gets the number of bitplanes used for each of the color components in\n"
"the color buffer. Pass NULL for any of the arguments if the value is\n"
"not required.\n" },
    { "perspective", (PyCFunction)_wrap_cogl_perspective, METH_VARARGS|METH_KEYWORDS,
      (char *) "Replaces the current projection matrix with a perspective matrix based\n"
"on the provided values.\n" },
    { "frustum", (PyCFunction)_wrap_cogl_frustum, METH_VARARGS|METH_KEYWORDS,
      (char *) "Replaces the current projection matrix with a perspective matrix for\n"
"the given viewing frustum.\n" },
    { "ortho", (PyCFunction)_wrap_cogl_ortho, METH_VARARGS|METH_KEYWORDS,
      (char *) "the plane is behind the viewer) the plane is behind the viewer)\n"
"Replaces the current projection matrix with a parallel projection\n"
"matrix.\n" },
    { "push_matrix", (PyCFunction)_wrap_cogl_push_matrix, METH_NOARGS,
      (char *) "Stores the current model-view matrix on the matrix stack. The matrix\n"
"can later be restored with cogl_pop_matrix().\n" },
    { "pop_matrix", (PyCFunction)_wrap_cogl_pop_matrix, METH_NOARGS,
      (char *) "Restores the current model-view matrix from the matrix stack.\n" },
    { "scale", (PyCFunction)_wrap_cogl_scale, METH_VARARGS|METH_KEYWORDS,
      (char *) "Multiplies the current model-view matrix by one that scales the x, y\n"
"and z axes by the given values.\n" },
    { "translate", (PyCFunction)_wrap_cogl_translate, METH_VARARGS|METH_KEYWORDS,
      (char *) "Multiplies the current model-view matrix by one that translates the\n"
"model along all three axes according to the given values.\n" },
    { "rotate", (PyCFunction)_wrap_cogl_rotate, METH_VARARGS|METH_KEYWORDS,
      (char *) "Multiplies the current model-view matrix by one that rotates the model\n"
"around the vertex specified by x, y and z. The rotation follows the\n"
"right-hand thumb rule so for example rotating by 10 degrees about the\n"
"vertex (0, 0, 1) causes a small counter-clockwise rotation.\n" },
    { "get_modelview_matrix", (PyCFunction)_wrap_cogl_get_modelview_matrix, METH_NOARGS,
      (char *) "Stores the current model-view matrix in matrix.\n" },
    { "set_modelview_matrix", (PyCFunction)_wrap_cogl_set_modelview_matrix, METH_VARARGS,
      (char *) "Loads matrix as the new model-view matrix.\n" },
    { "get_projection_matrix", (PyCFunction)_wrap_cogl_get_projection_matrix, METH_NOARGS,
      (char *) "Stores the current projection matrix in matrix.\n" },
    { "set_projection_matrix", (PyCFunction)_wrap_cogl_set_projection_matrix, METH_VARARGS,
      (char *) "Loads matrix as the new projection matrix.\n" },
    { "get_viewport", (PyCFunction)_wrap_cogl_get_viewport, METH_NOARGS,
      (char *) "of float<!-- -->s to receive the viewport dimensions. Stores the\n"
"current viewport in v. v[0] and v[1] get the x and y position of the\n"
"viewport and v[2] and v[3] get the width and height.\n" },
    { "set_depth_test_enabled", (PyCFunction)_wrap_cogl_set_depth_test_enabled, METH_VARARGS|METH_KEYWORDS,
      (char *) "Sets whether depth testing is enabled. If it is disabled then the\n"
"order that actors are layered on the screen depends solely on the\n"
"order specified using clutter.Actor.raise() and clutter.Actor.lower(),\n"
"otherwise it will also take into account the actor's depth. Depth\n"
"testing is disabled by default.\n" },
    { "get_depth_test_enabled", (PyCFunction)_wrap_cogl_get_depth_test_enabled, METH_NOARGS,
      (char *) "Queries if depth testing has been enabled via\n"
"cogl_set_depth_test_enable()\n" },
    { "set_backface_culling_enabled", (PyCFunction)_wrap_cogl_set_backface_culling_enabled, METH_VARARGS|METH_KEYWORDS,
      (char *) "Sets whether textures positioned so that their backface is showing\n"
"should be hidden. This can be used to efficiently draw two-sided\n"
"textures or fully closed cubes without enabling depth testing. This\n"
"only affects calls to the cogl_rectangle* family of functions and\n"
"cogl_vertex_buffer_draw*. Backface culling is disabled by default.\n" },
    { "get_backface_culling_enabled", (PyCFunction)_wrap_cogl_get_backface_culling_enabled, METH_NOARGS,
      (char *) "Queries if backface culling has been enabled via\n"
"cogl_set_backface_culling_enabled()\n" },
    { "set_fog", (PyCFunction)_wrap_cogl_set_fog, METH_VARARGS|METH_KEYWORDS,
      (char *) "fogging blend factor. COGL_FOG_MODE_EXPONENTIAL_SQUARED equations.\n"
"Enables fogging. Fogging causes vertices that are further away from\n"
"the eye to be rendered with a different color. The color is determined\n"
"according to the chosen fog mode; at it's simplest the color is\n"
"linearly interpolated so that vertices at z_near are drawn fully with\n"
"their original color and vertices at z_far are drawn fully with\n"
"fog_color. Fogging will remain enabled until you call\n"
"cogl_disable_fog(). <note>The fogging functions only work correctly\n"
"when primitives use unmultiplied alpha colors. By default Cogl will\n"
"premultiply textures and cogl_set_source_color() will premultiply\n"
"colors, so unless you explicitly load your textures requesting an\n"
"unmultiplied internal format and use cogl_material_set_color() you can\n"
"only use fogging with fully opaque primitives. This might improve in\n"
"the future when we can depend on fragment shaders.</note>\n" },
    { "disable_fog", (PyCFunction)_wrap_cogl_disable_fog, METH_NOARGS,
      (char *) "This function disables fogging, so primitives drawn afterwards will\n"
"not be blended with any previously set fog color.\n" },
    { "clear", (PyCFunction)_wrap_cogl_clear, METH_VARARGS|METH_KEYWORDS,
      (char *) "buffers to clear Clears all the auxiliary buffers identified in the\n"
"buffers mask, and if that includes the color buffer then the specified\n"
"color is used.\n" },
    { "set_source", (PyCFunction)_wrap_cogl_set_source, METH_VARARGS,
      (char *) "This function sets the source material that will be used to fill\n"
"subsequent geometry emitted via the cogl API. <note>In the future we\n"
"may add the ability to set a front facing material, and a back facing\n"
"material, in which case this function will set both to the\n"
"same.</note>\n" },
    { "set_source_color", (PyCFunction)_wrap_cogl_set_source_color, METH_VARARGS,
      (char *) "This is a convenience function for creating a solid fill source\n"
"material from the given color. This color will be used for any\n"
"subsequent drawing operation. The color will be premultiplied by Cogl,\n"
"so the color should be semi-transparent red. See also\n"
"cogl_set_source_color4ub() and cogl_set_source_color4f() if you\n"
"already have the color components.\n" },
    { "set_source_color4ub", (PyCFunction)_wrap_cogl_set_source_color4ub, METH_VARARGS|METH_KEYWORDS,
      (char *) "This is a convenience function for creating a solid fill source\n"
"material from the given color using unsigned bytes for each component.\n"
"This color will be used for any subsequent drawing operation. The\n"
"value for each component is an unsigned byte in the range between 0\n"
"and 255.\n" },
    { "set_source_color4f", (PyCFunction)_wrap_cogl_set_source_color4f, METH_VARARGS|METH_KEYWORDS,
      (char *) "This is a convenience function for creating a solid fill source\n"
"material from the given color using normalized values for each\n"
"component. This color will be used for any subsequent drawing\n"
"operation. The value for each component is a fixed point number in the\n"
"range between 0 and 1.0. If the values passed in are outside that\n"
"range, they will be clamped.\n" },
    { "set_source_texture", (PyCFunction)_wrap_cogl_set_source_texture, METH_VARARGS,
      (char *) "This is a convenience function for creating a material with the first\n"
"layer set to texture_handle and setting that material as the source\n"
"with cogl_set_source. and cogl_set_source_texture. If you need to\n"
"blend a texture with a color then you can create a simple material\n"
"like this: <programlisting> material = cogl_material_new ();\n"
"cogl_material_set_color4ub (material, 0xff, 0x00, 0x00, 0x80);\n"
"cogl_material_set_layer (material, 0, tex_handle); cogl_set_source\n"
"(material); </programlisting>\n" },
    { "clip_push_from_path", (PyCFunction)_wrap_cogl_clip_push_from_path, METH_NOARGS,
      (char *) "Sets a new clipping area using the current path. The current path is\n"
"then cleared. The clipping area is intersected with the previous\n"
"clipping area. To restore the previous clipping area, call\n"
"cogl_clip_pop().\n" },
    { "clip_push_from_path_preserve", (PyCFunction)_wrap_cogl_clip_push_from_path_preserve, METH_NOARGS,
      (char *) "Sets a new clipping area using the current path. The current path is\n"
"then cleared. The clipping area is intersected with the previous\n"
"clipping area. To restore the previous clipping area, call\n"
"cogl_clip_pop().\n" },
    { "clip_pop", (PyCFunction)_wrap_cogl_clip_pop, METH_NOARGS,
      (char *) "Reverts the clipping region to the state before the last call to\n"
"cogl_clip_push().\n" },
    { "flush", (PyCFunction)_wrap_cogl_flush, METH_NOARGS,
      (char *) "This function should only need to be called in exceptional\n"
"circumstances. As an optimization Cogl drawing functions may batch up\n"
"primitives internally, so if you are trying to use raw GL outside of\n"
"Cogl you stand a better chance of being successful if you ask Cogl to\n"
"flush any batched geometry before making your state changes. It only\n"
"ensure that the underlying driver is issued all the commands necessary\n"
"to draw the batched primitives. It provides no guarantees about when\n"
"the driver will complete the rendering. This provides no guarantees\n"
"about the GL state upon returning and to avoid confusing Cogl you\n"
"should aim to restore any changes you make before resuming use of\n"
"Cogl. If you are making state changes with the intention of affecting\n"
"Cogl drawing primitives you are 100 on your own since you stand a good\n"
"chance of conflicting with Cogl internals. For example clutter-gst\n"
"which currently uses direct GL calls to bind ARBfp programs will very\n"
"likely break when Cogl starts to use ARBfb programs itself for the\n"
"material API.\n" },
    { "begin_gl", (PyCFunction)_wrap_cogl_begin_gl, METH_NOARGS,
      (char *) "We do not advise nor reliably support the interleaving of raw GL\n"
"drawing and Cogl drawing functions, but if you insist, cogl_begin_gl()\n"
"and cogl_end_gl() provide a simple mechanism that may at least give\n"
"you a fighting chance of succeeding. through the modification of GL\n"
"state; that will never be reliably supported, but if you are trying to\n"
"do something like: |[ { - setup some OpenGL state. - draw using OpenGL\n"
"(e.g. glDrawArrays() ) - reset modified OpenGL state. - continue using\n"
"Cogl to draw } ]| You should surround blocks of drawing using raw GL\n"
"with cogl_begin_gl() and cogl_end_gl(): |[ { cogl_begin_gl (); - setup\n"
"some OpenGL state. - draw using OpenGL (e.g. glDrawArrays() ) - reset\n"
"modified OpenGL state. cogl_end_gl (); - continue using Cogl to draw }\n"
"]| Don't ever try and do: |[ { - setup some OpenGL state. - use Cogl\n"
"to draw - reset modified OpenGL state. } ]| When the internals of Cogl\n"
"evolves, this is very liable to break. This function will flush all\n"
"batched primitives, and subsequently flush all internal Cogl state to\n"
"OpenGL as if it were going to draw something itself. The result is\n"
"that the OpenGL modelview matrix will be setup; the state\n"
"corresponding to the current source material will be set up and other\n"
"world state such as backface culling, depth and fogging enabledness\n"
"will be sent to OpenGL. <note>No special material state is flushed, so\n"
"if you want Cogl to setup a simplified material state it is your\n"
"responsibility to set a simple source material before calling\n"
"cogl_begin_gl(). E.g. by calling cogl_set_source_color4ub().</note>\n"
"<note>It is your responsibility to restore any OpenGL state that you\n"
"modify to how it was after calling cogl_begin_gl() if you don't do\n"
"this then the result of further Cogl calls is undefined.</note>\n"
"<note>You can not nest begin/end blocks.</note> Again we would like to\n"
"stress, we do not advise the use of this API and if possible we would\n"
"prefer to improve Cogl than have developers require raw OpenGL.\n" },
    { "end_gl", (PyCFunction)_wrap_cogl_end_gl, METH_NOARGS,
      (char *) "This is the counterpart to cogl_begin_gl() used to delimit blocks of\n"
"drawing code using raw OpenGL. Please refer to cogl_begin_gl() for\n"
"full details.\n" },
    { "set_viewport", (PyCFunction)_wrap_cogl_set_viewport, METH_VARARGS|METH_KEYWORDS,
      (char *) "Replaces the current viewport with the given values.\n" },
    { "clip_push_window_rectangle", (PyCFunction)_wrap_cogl_clip_push_window_rectangle, METH_VARARGS|METH_KEYWORDS,
      (char *) "Specifies a rectangular clipping area for all subsequent drawing\n"
"operations. Any drawing commands that extend outside the rectangle\n"
"will be clipped so that only the portion inside the rectangle will be\n"
"displayed. The rectangle dimensions are transformed by the current\n"
"model-view matrix. The rectangle is intersected with the current clip\n"
"region. To undo the effect of this function, call cogl_clip_pop().\n"
"with other API that specify rectangles in model space, and when used\n"
"with a coordinate space that puts the origin at the center and y+\n"
"extending up, it's awkward to use. Please use\n"
"cogl_clip_push_rectangle() instead\n" },
    { "clip_push_rectangle", (PyCFunction)_wrap_cogl_clip_push_rectangle, METH_VARARGS|METH_KEYWORDS,
      (char *) "Specifies a rectangular clipping area for all subsequent drawing\n"
"operations. Any drawing commands that extend outside the rectangle\n"
"will be clipped so that only the portion inside the rectangle will be\n"
"displayed. The rectangle dimensions are transformed by the current\n"
"model-view matrix. The rectangle is intersected with the current clip\n"
"region. To undo the effect of this function, call cogl_clip_pop().\n" },
    { "set_framebuffer", (PyCFunction)_wrap_cogl_set_framebuffer, METH_O,
      (char *) "offscreen. This redirects all subsequent drawing to the specified\n"
"framebuffer. This can either be an offscreen buffer created with\n"
"cogl_offscreen_new_to_texture () or you can revert to your original\n"
"onscreen window buffer.\n" },
    { "push_framebuffer", (PyCFunction)_wrap_cogl_push_framebuffer, METH_O,
      (char *) "offscreen. Redirects all subsequent drawing to the specified\n"
"framebuffer. This can either be an offscreen buffer created with\n"
"cogl_offscreen_new_to_texture () or you can revert to your original\n"
"onscreen window buffer. The previous framebuffer can be restored by\n"
"calling cogl_pop_framebuffer()\n" },
    { "pop_framebuffer", (PyCFunction)_wrap_cogl_pop_framebuffer, METH_NOARGS,
      (char *) "Restores the framebuffer that was previously at the top of the stack.\n"
"All subsequent drawing will be redirected to this framebuffer.\n" },
    { "pango_ensure_glyph_cache_for_layout", (PyCFunction)_wrap_cogl_pango_ensure_glyph_cache_for_layout, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "pango_renderer_get_type", (PyCFunction)_wrap_cogl_pango_renderer_get_type, METH_NOARGS,
      NULL },
    { "pango_render_layout_subpixel", (PyCFunction)_wrap_cogl_pango_render_layout_subpixel, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "pango_render_layout", (PyCFunction)_wrap_cogl_pango_render_layout, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "pango_render_layout_line", (PyCFunction)_wrap_cogl_pango_render_layout_line, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "rectangle", (PyCFunction)_wrap_cogl_rectangle, METH_VARARGS|METH_KEYWORDS,
      (char *) "Fills a rectangle at the given coordinates with the current source\n"
"material\n" },
    { "path_fill", (PyCFunction)_wrap_cogl_path_fill, METH_NOARGS,
      (char *) "Fills the constructed shape using the current drawing color. The\n"
"current path is then cleared. To use the path again, call\n"
"cogl_path_fill_preserve() instead.\n" },
    { "path_fill_preserve", (PyCFunction)_wrap_cogl_path_fill_preserve, METH_NOARGS,
      (char *) "Fills the constructed shape using the current drawing color and\n"
"preserves the path to be used again.\n" },
    { "path_stroke", (PyCFunction)_wrap_cogl_path_stroke, METH_NOARGS,
      (char *) "Strokes the constructed shape using the current drawing color and a\n"
"width of 1 pixel (regardless of the current transformation matrix). To\n"
"current path is then cleared. To use the path again, call\n"
"cogl_path_stroke_preserve() instead.\n" },
    { "path_stroke_preserve", (PyCFunction)_wrap_cogl_path_stroke_preserve, METH_NOARGS,
      (char *) "Strokes the constructed shape using the current drawing color and\n"
"preserves the path to be used again.\n" },
    { "path_new", (PyCFunction)_wrap_cogl_path_new, METH_NOARGS,
      (char *) "Clears the current path and starts a new one.\n" },
    { "path_move_to", (PyCFunction)_wrap_cogl_path_move_to, METH_VARARGS|METH_KEYWORDS,
      (char *) "Moves the pen to the given location. If there is an existing path this\n"
"will start a new disjoint subpath.\n" },
    { "path_rel_move_to", (PyCFunction)_wrap_cogl_path_rel_move_to, METH_VARARGS|METH_KEYWORDS,
      (char *) "Moves the pen to the given offset relative to the current pen\n"
"location. If there is an existing path this will start a new disjoint\n"
"subpath.\n" },
    { "path_line_to", (PyCFunction)_wrap_cogl_path_line_to, METH_VARARGS|METH_KEYWORDS,
      (char *) "Constructs a straight line shape starting and ending at the given\n"
"coordinates. If there is an existing path this will start a new\n"
"disjoint sub-path.\n" },
    { "path_rel_line_to", (PyCFunction)_wrap_cogl_path_rel_line_to, METH_VARARGS|METH_KEYWORDS,
      (char *) "Adds a straight line segment to the current path that ends at the\n"
"given coordinates relative to the current pen location.\n" },
    { "path_arc", (PyCFunction)_wrap_cogl_path_arc, METH_VARARGS|METH_KEYWORDS,
      (char *) "Adds an elliptical arc segment to the current path. A straight line\n"
"segment will link the current pen location with the first vertex of\n"
"the arc. If you perform a move_to to the arcs start just before\n"
"drawing it you create a free standing arc.\n" },
    { "path_curve_to", (PyCFunction)_wrap_cogl_path_curve_to, METH_VARARGS|METH_KEYWORDS,
      (char *) "Adds a cubic bezier curve segment to the current path with the given\n"
"second, third and fourth control points and using current pen location\n"
"as the first control point.\n" },
    { "path_rel_curve_to", (PyCFunction)_wrap_cogl_path_rel_curve_to, METH_VARARGS|METH_KEYWORDS,
      (char *) "Adds a cubic bezier curve segment to the current path with the given\n"
"second, third and fourth control points and using current pen location\n"
"as the first control point. The given coordinates are relative to the\n"
"current pen location.\n" },
    { "path_close", (PyCFunction)_wrap_cogl_path_close, METH_NOARGS,
      (char *) "Closes the path being constructed by adding a straight line segment to\n"
"it that ends at the first vertex of the path.\n" },
    { "path_line", (PyCFunction)_wrap_cogl_path_line, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "path_polyline", (PyCFunction)_wrap_cogl_path_polyline, METH_VARARGS,
      (char *) "array of fixed-point values that specify the vertex coordinates.\n"
"Constructs a series of straight line segments, starting from the first\n"
"given vertex coordinate. If there is an existing path this will start\n"
"a new disjoint sub-path. Each subsequent segment starts where the\n"
"previous one ended and ends at the next given vertex coordinate. The\n"
"coords array must contain 2 * num_points values. The first value\n"
"represents the X coordinate of the first vertex, the second value\n"
"represents the Y coordinate of the first vertex, continuing in the\n"
"same fashion for the rest of the vertices. (num_points - 1) segments\n"
"will be constructed.\n" },
    { "path_polygon", (PyCFunction)_wrap_cogl_path_polygon, METH_VARARGS,
      (char *) "an array of fixed-point values that specify the vertex coordinates.\n"
"Constructs a polygonal shape of the given number of vertices. If there\n"
"is an existing path this will start a new disjoint sub-path. The\n"
"coords array must contain 2 * num_points values. The first value\n"
"represents the X coordinate of the first vertex, the second value\n"
"represents the Y coordinate of the first vertex, continuing in the\n"
"same fashion for the rest of the vertices.\n" },
    { "path_rectangle", (PyCFunction)_wrap_cogl_path_rectangle, METH_VARARGS|METH_KEYWORDS,
      (char *) "Constructs a rectangular shape at the given coordinates. If there is\n"
"an existing path this will start a new disjoint sub-path.\n" },
    { "path_ellipse", (PyCFunction)_wrap_cogl_path_ellipse, METH_VARARGS|METH_KEYWORDS,
      (char *) "Constructs an ellipse shape. If there is an existing path this will\n"
"start a new disjoint sub-path.\n" },
    { "path_round_rectangle", (PyCFunction)_wrap_cogl_path_round_rectangle, METH_VARARGS|METH_KEYWORDS,
      (char *) "the corner arcs. Constructs a rectangular shape with rounded corners.\n"
"If there is an existing path this will start a new disjoint sub-path.\n" },
    { "texture_new_with_size", (PyCFunction)_wrap_cogl_texture_new_with_size, METH_VARARGS|METH_KEYWORDS,
      (char *) "texture. Creates a new COGL texture with the specified dimensions and\n"
"pixel format. COGL_INVALID_HANDLE on failure\n" },
    { "texture_new_from_file", (PyCFunction)_wrap_cogl_texture_new_from_file, METH_VARARGS|METH_KEYWORDS,
      (char *) "texture. If COGL_PIXEL_FORMAT_ANY is given then a premultiplied format\n"
"similar to the format of the source data will be used. The default\n"
"blending equations of Cogl expect premultiplied color data; the main\n"
"use of passing a non-premultiplied format here is if you have non-\n"
"premultiplied source data and are going to adjust the blend mode (see\n"
"cogl_material_set_blend()) or use the data for something other than\n"
"straight blending. Creates a COGL texture from an image file.\n"
"COGL_INVALID_HANDLE on failure\n" },
    { "texture_new_from_data", (PyCFunction)_wrap_cogl_texture_new_from_data, METH_VARARGS|METH_KEYWORDS,
      (char *) "the buffer on the GPU. If COGL_PIXEL_FORMAT_ANY is given then a\n"
"premultiplied format similar to the format of the source data will be\n"
"used. The default blending equations of Cogl expect premultiplied\n"
"color data; the main use of passing a non-premultiplied format here is\n"
"if you have non-premultiplied source data and are going to adjust the\n"
"blend mode (see cogl_material_set_blend()) or use the data for\n"
"something other than straight blending. scanlines in data Creates a\n"
"new COGL texture based on data residing in memory. COGL_INVALID_HANDLE\n"
"on failure\n" },
    { "texture_new_from_foreign", (PyCFunction)_wrap_cogl_texture_new_from_foreign, METH_VARARGS|METH_KEYWORDS,
      (char *) "Creates a COGL texture based on an existing OpenGL texture; the width,\n"
"height and format are passed along since it is not always possible to\n"
"query these from OpenGL. The waste arguments allow you to create a\n"
"Cogl texture that maps to a region smaller than the real OpenGL\n"
"texture. For instance if your hardware only supports power-of-two\n"
"textures you may load a non-power-of-two image into a larger power-of-\n"
"two texture and use the waste arguments to tell Cogl which region\n"
"should be mapped to the texture coordinate range [0:1].\n"
"COGL_INVALID_HANDLE on failure\n" },
    { "texture_new_from_bitmap", (PyCFunction)_wrap_cogl_texture_new_from_bitmap, METH_VARARGS|METH_KEYWORDS,
      (char *) "texture Creates a COGL texture from a CoglBitmap. COGL_INVALID_HANDLE\n"
"on failure\n" },
    { "rectangle_with_texture_coords", (PyCFunction)_wrap_cogl_rectangle_with_texture_coords, METH_VARARGS,
      (char *) "Draw a rectangle using the current material and supply texture\n"
"coordinates to be used for the first texture layer of the material. To\n"
"draw the entire texture pass in tx1=0.0 ty1=0.0 tx2=1.0 ty2=1.0.\n" },
    { "rectangle_with_multitexture_coords", (PyCFunction)_wrap_cogl_rectangle_with_multitexture_coords, METH_VARARGS,
      (char *) "coordinates; one for the upper left texel, and one for the lower right\n"
"texel. Each value should be between 0.0 and 1.0, where the coordinate\n"
"(0.0, 0.0) represents the top left of the texture, and (1.0, 1.0) the\n"
"bottom right. and one group of texture coordinates, this would be 4)\n"
"This function draws a rectangle using the current source material to\n"
"texture or fill with. As a material may contain multiple texture\n"
"layers this interface lets you supply texture coordinates for each\n"
"layer of the material. The first pair of coordinates are for the first\n"
"layer (with the smallest layer index) and if you supply less texture\n"
"coordinates than there are layers in the current source material then\n"
"default texture coordinates (0.0, 0.0, 1.0, 1.0) are generated.\n" },
    { "rectangles_with_texture_coords", (PyCFunction)_wrap_cogl_rectangles_with_texture_coords, METH_VARARGS,
      (char *) "Draws a series of rectangles in the same way that cogl_rectangle()\n"
"does. In some situations it can give a significant performance boost\n"
"to use this function rather than calling cogl_rectangle() separately\n"
"for each rectangle. parameters x1, y1, x2, and y2, and have the same\n"
"meaning as in cogl_rectangle().\n" },
    { "rectangles", (PyCFunction)_wrap_cogl_rectangles, METH_VARARGS,
      NULL },
    { "polygon", (PyCFunction)_wrap_cogl_polygon, METH_VARARGS|METH_KEYWORDS,
      (char *) "Draws a convex polygon using the current source material to fill /\n"
"texture with according to the texture coordinates passed. If use_color\n"
"is TRUE then the color will be changed for each vertex using the value\n"
"specified in the color member of CoglTextureVertex. This can be used\n"
"for example to make the texture fade out by setting the alpha value of\n"
"the color. All of the texture coordinates must be in the range [0,1]\n"
"and repeating the texture is not supported. Because of the way this\n"
"function is implemented it will currently only work if either the\n"
"texture is not sliced or the backend is not OpenGL ES and the\n"
"minifying and magnifying functions are both set to\n"
"COGL_MATERIAL_FILTER_NEAREST.\n" },
    { "texture_new_from_sub_texture", (PyCFunction)_wrap_cogl_texture_new_from_sub_texture, METH_VARARGS|METH_KEYWORDS,
      (char *) "Creates a new texture which represents a subregion of another texture.\n"
"The GL resources will be shared so that no new texture data is\n"
"actually allocated. Sub textures have undefined behaviour texture\n"
"coordinates outside of the range [0,1] are used. They also do not work\n"
"with CoglVertexBuffers. The sub texture will keep a reference to the\n"
"full texture so you do not need to keep one separately if you only\n"
"want to use the sub texture.\n" },
    { "handle_get_type", (PyCFunction)_wrap_cogl_handle_get_type, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};


/* ----------- enums and flags ----------- */

void
pycogl_add_constants(PyObject *module, const gchar *strip_prefix)
{
#ifdef VERSION
    PyModule_AddStringConstant(module, "__version__", VERSION);
#endif
  pyg_flags_add(module, "BufferBit", strip_prefix, COGL_TYPE_BUFFER_BIT);
  pyg_enum_add(module, "ShaderType", strip_prefix, COGL_TYPE_SHADER_TYPE);
  pyg_enum_add(module, "PixelFormat", strip_prefix, COGL_TYPE_PIXEL_FORMAT);
  pyg_flags_add(module, "FeatureFlags", strip_prefix, COGL_TYPE_FEATURE_FLAGS);
  pyg_flags_add(module, "BufferTarget", strip_prefix, COGL_TYPE_BUFFER_TARGET);
  pyg_flags_add(module, "TextureFlags", strip_prefix, COGL_TYPE_TEXTURE_FLAGS);
  pyg_enum_add(module, "FogMode", strip_prefix, COGL_TYPE_FOG_MODE);
  pyg_enum_add(module, "MaterialFilter", strip_prefix, COGL_TYPE_MATERIAL_FILTER);
  pyg_enum_add(module, "MaterialAlphaFunc", strip_prefix, COGL_TYPE_MATERIAL_ALPHA_FUNC);
  pyg_enum_add(module, "MaterialLayerType", strip_prefix, COGL_TYPE_MATERIAL_LAYER_TYPE);
  pyg_enum_add(module, "AttributeType", strip_prefix, COGL_TYPE_ATTRIBUTE_TYPE);
  pyg_enum_add(module, "VerticesMode", strip_prefix, COGL_TYPE_VERTICES_MODE);
  pyg_enum_add(module, "IndicesType", strip_prefix, COGL_TYPE_INDICES_TYPE);
  pyg_flags_add(module, "ReadPixelsFlags", strip_prefix, COGL_TYPE_READ_PIXELS_FLAGS);
  pyg_enum_add(module, "BlendStringError", strip_prefix, COGL_TYPE_BLEND_STRING_ERROR);

  if (PyErr_Occurred())
    PyErr_Print();
}

/* initialise stuff extension classes */
void
pycogl_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("pango")) != NULL) {
        _PyPangoLayout_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Layout");
        if (_PyPangoLayout_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Layout from pango");
            return ;
        }
        _PyPangoLayoutLine_Type = (PyTypeObject *)PyObject_GetAttrString(module, "LayoutLine");
        if (_PyPangoLayoutLine_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name LayoutLine from pango");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import pango");
        return ;
    }
    if ((module = PyImport_ImportModule("pangocairo")) != NULL) {
        _PyPangoCairoFontMap_Type = (PyTypeObject *)PyObject_GetAttrString(module, "CairoFontMap");
        if (_PyPangoCairoFontMap_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name CairoFontMap from pangocairo");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import pangocairo");
        return ;
    }


#line 3814 "cogl.c"
    pygobject_register_class(d, "CoglPangoFontMap", COGL_PANGO_TYPE_FONT_MAP, &PyCoglPangoFontMap_Type, Py_BuildValue("(O)", &PyPangoCairoFontMap_Type));
    pyg_set_object_has_new_constructor(COGL_PANGO_TYPE_FONT_MAP);
}
